/*
 * Created on Jul 8, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jogl;

import java.util.ArrayList;
import java.util.List;

import javax.vecmath.Vector3d;

/**
 * @author golovins
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Grid {
	boolean opaque[][][];
	List objects[][][];

	Vector3d min, max, step;
	int size[];

	Grid(Mesh mesh, int nx, int ny, int nz){
		min = new Vector3d();
		max = new Vector3d();
		for(int i = 0; i < mesh.vertices.size(); i++){
			Vertex v = (Vertex)mesh.vertices.get(i);
			if(v.pos.x < min.x) min.x = v.pos.x;
			if(v.pos.y < min.y) min.y = v.pos.y;
			if(v.pos.z < min.z) min.z = v.pos.z;
			
			if(v.pos.x > max.x) max.x = v.pos.x;
			if(v.pos.y > max.y) max.y = v.pos.y;
			if(v.pos.z > max.z) max.z = v.pos.z;
		}
	    Vector3d displacement = new Vector3d(.001, .001, .001);
	    max.add(displacement);
	    min.sub(displacement);
		
		System.out.println("    grid min: " + min);
		System.out.println("    grid max: " + max);

		size = new int[3];
		size[0] = nx; size[1] = ny; size[2] = nz;
//		min = new Vector3d(mn);
//		max = new Vector3d(mx);
		step = new Vector3d();
		step.sub(max, min);
		step.x /= nx;
		step.y /= ny;
		step.z /= nz;
		
		opaque = new boolean[nx][ny][nz];
		objects = new List[nx][ny][nz];
		for(int i = 0; i < nx; i++)
			for(int j = 0; j < ny; j++)
				for(int k = 0; k < nz; k++)
					objects[i][j][k] = new ArrayList();
		
		for(int i = 0; i < mesh.faces.size(); i++){
			Face f = (Face)mesh.faces.get(i);
			Add(f);
		}
		
		/*
		for(int i = 0; i < nx; i++)
			for(int j = 0; j < ny; j++)
				for(int k = 0; k < nz; k++)
					System.out.println(objects[i][j][k].size());
					*/		

	}
	
	static final double eps = .0000001;
	
	boolean intersects(Ray r, Face f, Hit h){
		Vector3d intersection = Correspondence.triangleRayIntersect(f.verts[0].pos, f.verts[1].pos, f.verts[2].pos, 
																	r.origin, r.direction);
		
		if(intersection.y >= -eps && intersection.z >= -eps && intersection.y + intersection.z <= 1 + eps){
			if(intersection.x >= -eps && intersection.x < h.t){
				h.t = intersection.x;
				h.intersectionPoint = r.pointAtParameter(h.t);
				return true;
			}
		}
		return false;
	}
	
	boolean traceRay(Ray r, Hit h, float tmin, boolean visualize_grid){
		MarchingInfo m = new MarchingInfo();
		boolean hitGrid  = initializeRayMarch(m, r, tmin);
		if(!hitGrid) return false;		
		
		Vector3d epsDisplacement = new Vector3d(.00001, .00001, .00001);
		/*
		h.intersectionPoint = r.origin;
		if(h.intersectionPoint != null)
			return true;
			*/
		
		//System.out.println("Tracing");
		Vector3d cellMin = new Vector3d(step), cellMax = new Vector3d(step);
		while(m.i >= 0 && m.j >= 0 && m.k >= 0 && m.i < size[0] && m.j < size[1] && m.k < size[2]){
			//System.out.println(m.i + " " + m.j + " " + m.k + "; " + m.tmin);
			if(visualize_grid){
				if(objects[m.i][m.j][m.k].size() > 0 /*&& m.tmin > tmin && m.tmin < h.t*/){
					h.t = m.tmin;
					h.intersectionPoint = r.pointAtParameter(h.t);
					return true;
				}
			}
			else{
				boolean hit = false;
				cellMin.set(step);
				cellMax.set(step);
				cellMin.x *= m.i;
				cellMin.y *= m.j;
				cellMin.z *= m.k;
				cellMin.add(min);
				cellMin.sub(epsDisplacement);
				cellMax.x *= (m.i + 1);
				cellMax.y *= (m.j + 1);
				cellMax.z *= (m.k + 1);
				cellMax.add(min);
				cellMax.add(epsDisplacement);
	            
				for(int i = 0; i < objects[m.i][m.j][m.k].size(); i++){
					Face f = (Face)objects[m.i][m.j][m.k].get(i);
					if(intersects(r, f, h)){
						Vector3d point = h.intersectionPoint; //intersection point
						if(/*h.t >= tmin &&*/
							point.x < cellMax.x && point.x >= cellMin.x &&
							point.y < cellMax.y && point.y >= cellMin.y &&
							point.z < cellMax.z && point.z >= cellMin.z){//hit object inside cell
							hit = true;

//							h.t = m.tmin;
//							h.intersectionPoint = r.pointAtParameter(h.t);
							
						}
						else if(!hit){
							//h.set(FLT_MAX, NULL, Vec3f(0, 0, 0), r);
							h.t = Double.POSITIVE_INFINITY;
							h.intersectionPoint = null;
						}
					}	  
				}
				if(hit) return true;
			}
			m.nextCell();
		}    

		return false;
		
	}

	boolean initializeRayMarch(MarchingInfo mi, Ray r, float tmin){
		mi.tmin = tmin;
		Vector3d o = new Vector3d(r.origin);
		Vector3d dir = new Vector3d(r.direction);
		mi.sign_x = 1; if(dir.x < 0) mi.sign_x = -1;
		mi.sign_y = 1; if(dir.y < 0) mi.sign_y = -1;
		mi.sign_z = 1; if(dir.z < 0) mi.sign_z = -1;

		mi.dt.set(Math.abs(step.x / dir.x), Math.abs(step.y / dir.y), Math.abs(step.z / dir.z));		  

		boolean inside = false;
		Vector3d fromMin = new Vector3d();
		fromMin.sub(o , min);
		Vector3d toMax = new Vector3d();
		toMax.sub(max,o);
		if(fromMin.x > 0 && fromMin.y > 0 && fromMin.z > 0 &&
				toMax.x > 0 && toMax.y > 0 && toMax.z > 0) 
				inside = true;

		if(inside){
		    //    cout << "ray started inside grid" << endl;
		    getMarchInfo(mi, fromMin, dir);
		}
		else{ //ray begins outside
			double t, tInter = Double.POSITIVE_INFINITY; 
		    Vector3d point = new Vector3d();
		    t = (min.x - o.x)/dir.x;
		    point = r.pointAtParameter(t);
		    if(point.y > min.y && point.y < max.y && point.z > min.z && point.z < max.z && t > 0){
		      tInter = t;
		    }
		    t = (max.x - o.x)/dir.x;
		    point = r.pointAtParameter(t);
		    if(point.y > min.y && point.y < max.y && point.z > min.z && point.z < max.z && t < tInter && t > 0){
		      tInter = t;
		    }

		    t = (min.y - o.y)/dir.y;
		    point = r.pointAtParameter(t);
		    if(point.x > min.x && point.x < max.x && point.z > min.z && point.z < max.z && t < tInter && t > 0){
		      tInter = t;
		    }
		    t = (max.y - o.y)/dir.y;
		    //    cout << endl << t << ", point: " << point << endl;
		    point = r.pointAtParameter(t);
		    if(point.x > min.x && point.x < max.x && point.z > min.z && point.z < max.z && t < tInter && t > 0){
		      tInter = t;
		    }

		    t = (min.z - o.z)/dir.z;
		    point = r.pointAtParameter(t);
		    if(point.x > min.x && point.x < max.x && point.y > min.y && point.y < max.y && t < tInter && t > 0){
		      tInter = t;
		    }
		    t = (max.z - o.z)/dir.z;
		    point = r.pointAtParameter(t);
		    if(point.x > min.x && point.x < max.x && point.y > min.y && point.y < max.y && t < tInter && t > 0){
		      tInter = t;
		    }
		   
		    if(!(tInter < Double.POSITIVE_INFINITY) || tInter < tmin) return false;

		    Vector3d interPoint = r.pointAtParameter(tInter + .000001); //put yourself slightly inside the grid
		    fromMin.sub(interPoint, min);
		    //    cout << "from min: " << fromMin << endl;
		    getMarchInfo(mi, fromMin, dir);
		    mi.tmin = tInter;
		    mi.t_next.set(mi.t_next.x + tInter, mi.t_next.y + tInter, mi.t_next.z + tInter);
		  }
		  return true;
		
	}
	
	void getMarchInfo(MarchingInfo mi, Vector3d fromMin, Vector3d dir){ //assumes you are inside the grid
		Vector3d gridPos = new Vector3d(fromMin);
		gridPos.x /= step.x;
		gridPos.y /= step.y;
		gridPos.z /= step.z;
		mi.i = (int)gridPos.x; mi.j = (int)gridPos.y; mi.k = (int)gridPos.z;
		if(mi.i < 0 || mi.i >= size[0]) throw new RuntimeException("Starting out of grid!");
		if(mi.j < 0 || mi.j >= size[1]) throw new RuntimeException("Starting out of grid!");
		if(mi.k < 0 || mi.k >= size[2]) throw new RuntimeException("Starting out of grid!");
		float next_x = mi.i + 1; if(mi.sign_x < 0) next_x = mi.i;
		float next_y = mi.j + 1; if(mi.sign_y < 0) next_y = mi.j;
		float next_z = mi.k + 1; if(mi.sign_z < 0) next_z = mi.k;
		Vector3d gridIntersect = new Vector3d(step);
		gridIntersect.x *= next_x;
		gridIntersect.y *= next_y;
		gridIntersect.z *= next_z;
		
		Vector3d toIntersect = new Vector3d();
		toIntersect.sub(gridIntersect, fromMin);
		mi.t_next.set(toIntersect);
		mi.t_next.x /= dir.x;
		mi.t_next.y /= dir.y;
		mi.t_next.z /= dir.z;
		
		mi.t_next.x = Math.abs(mi.t_next.x);
		mi.t_next.y = Math.abs(mi.t_next.y);
		mi.t_next.z = Math.abs(mi.t_next.z);
	}


	void Add(Face f){		
		Vector3d objMin = new Vector3d(Double.POSITIVE_INFINITY, Double.POSITIVE_INFINITY, Double.POSITIVE_INFINITY);
		Vector3d objMax = new Vector3d(Double.NEGATIVE_INFINITY, Double.NEGATIVE_INFINITY, Double.NEGATIVE_INFINITY);
		for(int i = 0; i < 3; i++){
			Vertex v = f.verts[i];
			if(v.pos.x < objMin.x) objMin.x = v.pos.x;
			if(v.pos.y < objMin.y) objMin.y = v.pos.y;
			if(v.pos.z < objMin.z) objMin.z = v.pos.z;
			
			if(v.pos.x > objMax.x) objMax.x = v.pos.x;
			if(v.pos.y > objMax.y) objMax.y = v.pos.y;
			if(v.pos.z > objMax.z) objMax.z = v.pos.z;
		}
		
		int startIndex[] = new int[3],  endIndex[] = new int[3]; //grid indices in which corners of bounding box fall
		
		Vector3d gridPos = new Vector3d();
		gridPos.sub(objMin, min);
		
		gridPos.x /= step.x;
		gridPos.y /= step.y;
		gridPos.z /= step.z;

		startIndex[0] = (int)gridPos.x; startIndex[1] = (int)gridPos.y; startIndex[2] = (int)gridPos.z;

		gridPos.sub(objMax, min);
		gridPos.x /= step.x;
		gridPos.y /= step.y;
		gridPos.z /= step.z;
		
		endIndex[0] = (int)gridPos.x; endIndex[1] = (int)gridPos.y; endIndex[2] = (int)gridPos.z;
		  
		for(int x = startIndex[0]; x <= endIndex[0] && x < size[0]; x++)
			for(int y = startIndex[1]; y <= endIndex[1] && y < size[1]; y++)
				for(int z = startIndex[2]; z <= endIndex[2] && z < size[2]; z++){
					objects[x][y][z].add(f);
				}

	}

	private class MarchingInfo{
		double tmin;
		Vector3d t_next = new Vector3d(), dt = new Vector3d();
		int sign_x, sign_y, sign_z, i, j, k;
		
		void nextCell(){
			if(t_next.x < t_next.y && t_next.x < t_next.z){
				i += sign_x;
				tmin = t_next.x;
				t_next.set(t_next.x + dt.x, t_next.y, t_next.z);
			}
			else if(t_next.y < t_next.z){
				j += sign_y;
				tmin = t_next.y;
				t_next.set(t_next.x, t_next.y + dt.y, t_next.z);
			}
			else{
				k += sign_z;
				tmin = t_next.z;
				t_next.set(t_next.x, t_next.y, t_next.z + dt.z);
			}			
		}		
	}
	
	public class Ray{
		Vector3d direction;
		Vector3d origin;
		
		Ray (Vector3d dir, Vector3d orig) {
			direction = dir;
		    origin = orig; 
		}

		Vector3d pointAtParameter(double t){
		    Vector3d output = new Vector3d();
			output.scaleAdd(t, direction, origin);
		    return output; 
		}		  	
	}

	public class Hit {		 
		double t;
		Vector3d intersectionPoint;
		public Hit(){
			t = Double.POSITIVE_INFINITY;
		}
	}
}
