/*
 * Created on Jul 25, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jogl;

import net.java.games.jogl.GL;

/**
 * @author golovins
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Histogram {		
	static final float eps = .00001f;
	
	float[] counts;
	//for a probability density, number of hits between values[i] and values[i + 1]
	//for a CDF, number of hits <= values[i+1]
	
	float[] values;
	
	int bins;
	float min, max;
	float binSize;
	
	public Histogram(float min, float max){
		this.bins = ImageLoader.numBins;
		counts = new float[bins];
		values = new float[bins];
		this.min = min;
		this.max = max;
		binSize = (max - min) / bins;
	}
	
	public Histogram(Histogram H){
		this(H.min, H.max);
		
		for(int i = 0; i < bins; i++){
			values[i] = H.values[i];
			counts[i] = H.counts[i];
		}
	}
	
	public Histogram(Image image, int startX, int startY, int endX, int endY){
		this(image.min(startX, startY, endX, endY) - eps, image.max(startX, startY, endX, endY) + eps);

		for(int i = 0; i < bins; i++){
			values[i] = binSize * (i /*+ .5f*/) + min;
			counts[i] = 0;
		}
		
		for(int i = startX; i < endX; i++)
			for(int j = startY; j < endY; j++)
				counts[indexOf(image.data[i][j])]++;
		
		float sum = 0;
		for(int i = 0; i < bins; i++)
			sum += counts[i];
		
		for(int i = 0; i < bins; i++)
			counts[i] /= sum;
	}
	
	public Histogram(Image image){
		this(image, 0, 0, image.width, image.height);
	}	
	public int indexOf(float value){
		int index = (int)((value - min) / binSize);
		if(index >= bins) index = bins - 1;
		else if(index < 0) index = 0;
		return index;
	}
	
	public Histogram getCDF(){ //assumes this is a probability density
		Histogram CDF = new Histogram(this);
		float tally = 0;
		for(int i = 0; i < bins; i++){
			//System.out.println(tally + " " + counts[i]);
			tally += counts[i];
			CDF.counts[i] = tally;
		}
		return CDF;
	}
	
	public String toString(){
		String output = min + "/" + max + "\n";
		for(int i = 0; i < bins; i++)
			output += values[i] + "  ";
		output += "\n";
		for(int i = 0; i < bins; i++)
			output += counts[i] + "  ";
		return output;
	}
	
	public void draw(GL gl, int x, int y, int size, float minValue, float maxValue, Image image){
		//System.out.println();
		gl.glLineWidth(3.0f);
		gl.glBegin(GL.GL_LINE_STRIP);
		for(int i = 0; i < bins; i++){
			//float xPixel = ((float)i)/bins * size;
			float xPixel = (values[i] - minValue) / (maxValue - minValue) * size;
			float yPixel = counts[i] * size;
			//System.out.println(xPixel + ", " + yPixel);
			//System.out.println(xPixel + ", " + yPixel);
			int xImg = (int)xPixel;
			int yImg = (int)yPixel;
			if(xImg >= image.width) xImg = image.width - 1;
			if(yImg >= image.height) yImg = image.height - 1;
			if(xImg < 0) xImg = 0;
			if(yImg < 0) yImg = 0;
			
			float imageColor = image.data[xImg][yImg];
			gl.glColor3f(1 - imageColor, .5f, 1 - imageColor);
			gl.glVertex2f(xPixel + x, yPixel + y);
		}
		gl.glEnd();
	}
}
