/*
 * Created on Jul 25, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jogl;

/**
 * @author golovins
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class InverseCDF {
	//mapping from [0, 1] to value
	
	int bins;
	float[] values;
	
	public InverseCDF(){
		bins = ImageLoader.numBins;
		values = new float[bins];
	}
	
	public InverseCDF(Histogram CDF){
		this();
		// Create and initialize the inverse cdf with the index
		// and value of the last bin in the CDF
		for(int i = 0; i < bins; i++ )
		{
			values[i] = CDF.values[CDF.bins - 1];
		}
		
		// Compute the step size
		float step = 1.0f/bins;
		float nextSample = 0;
		
		// Generate the inverse cdf
		int CDFpos = 0;
		for(int  i = 0; i < CDF.bins; i++ )
		{
			// Skip to the position of the next sample
			// in the inverse histogram.
			while( CDFpos < CDF.bins && CDF.counts[CDFpos] <= nextSample )
				CDFpos++;

			// Compute the inverse cdf entry
			if( CDFpos < CDF.bins )
			{
				if( CDFpos > 0)
				{
					// Using linear interpolation, assign index of the
					// value in CDF that is nearest to NextSample.
					int CDFprev = CDFpos - 1;
					float A = CDF.values[CDFprev];
					float B = CDF.values[CDFpos];
					float test = (nextSample - A) / (B - A);
					if( test < 0.5f )
					{
						values[i] = CDF.values[CDFprev];
					} else {
						values[i] = CDF.values[CDFpos];
					}
					
				} else {
					// The sample lies before the first value in the cdf
					values[i] = CDF.values[0];
				}			

				// Mark the position of the next sample
				nextSample += step;
			} else
				// If we reach the end of CDF, then we are done
				// because we already filled ICDF with the index
				// of the last bin in CDF.
				break;
		}		
	}
	
	/*
	 * from [0, 1] to corresponding pixel value
	 */
	float getValue(float prob){
		int index = (int)(prob * bins);
		if(index >= bins){
			//System.out.println("index out of range: " + index);
			index = bins - 1;
		}
		return values[index];
	}
	
	/*
	public String toString(){
		String output = bins + "\n";
		for(int i = 0; i < bins; i++)
			output += values[i] + "  ";
		return output;
	}*/
	
	static public InverseCDF avg(InverseCDF[] inputs){		
		int numBins = inputs[0].bins;
		for(int i = 0; i < inputs.length; i++)
			if(inputs[i].bins != numBins)
				throw new RuntimeException();
		
		InverseCDF result = new InverseCDF();
		for(int i = 0; i < inputs.length; i++)
			for(int j = 0; j < numBins; j++)
				result.values[j] += inputs[i].values[j];
		
		for(int j = 0; j < numBins; j++)
			result.values[j] /= inputs.length;
		
		return result;
	}
	
	public String toString(){
		String output = "";
		int numSamples = 10;
		for(int i = 0; i < numSamples; i++){
			float prob = ((float)i) / numSamples;
			output += getValue(prob) + " ";
		}
		return output;
	}
}
