/*
 * Created on Aug 30, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jogl;

import java.io.BufferedOutputStream;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;

/**
 * @author golovins
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class LocalICDF extends LocalStats{
	/*
	int numStatisticsTiles = -1;
	int numChannels = -1;
	*/
	
	InverseCDF ICDF[][][];
	
	LocalICDF(String file){
		loadFrom(file);
	}
	
	LocalICDF(LocalICDF stats){
		numStatisticsTiles = stats.numStatisticsTiles;
		numChannels = stats.numChannels;
		ICDF = new InverseCDF[numChannels][numStatisticsTiles][numStatisticsTiles];
		for(int i = 0; i < numChannels; i++)
			for(int j = 0; j < numStatisticsTiles; j++)
				for(int k = 0; k < numStatisticsTiles; k++)
					ICDF[i][j][k] = stats.ICDF[i][j][k];
		
	}
	
	LocalICDF(int numChannels, int numStatisticsTiles){
		this.numChannels = numChannels;
		this.numStatisticsTiles = numStatisticsTiles;
		ICDF = new InverseCDF[numChannels][numStatisticsTiles][numStatisticsTiles];
	}
	
	LocalICDF(Image image, int levels){
		this(image, levels, ImageLoader.numStatisticTiles);
	}
	
	LocalICDF(Image image, int levels, int numStatisticsTiles){
		this.numStatisticsTiles = numStatisticsTiles;
		image.createSteerablePyramid(4, levels);
		ICDF = new InverseCDF[image.pyramid.bands.length][numStatisticsTiles][numStatisticsTiles];
		numChannels = image.pyramid.bands.length;
		for(int i = 0; i < image.pyramid.bands.length; i++){
			for(int j = 0; j < numStatisticsTiles; j++){				
				for(int k = 0; k < numStatisticsTiles; k++){
					ICDF[i][j][k] = image.pyramid.bands[i].statistics[j][k].ICDF;					
				}
			}
		}

	}
	
	void saveAs(String file){
		try{
			System.out.println("Saving HB stats to " + file);
			System.out.println("  ch: " + numChannels + " tiles: " + 
					numStatisticsTiles + " bins: " + ImageLoader.numBins);				
			int numBins = ICDF[0][0][0].bins;
			
			FileOutputStream fstream = new FileOutputStream(file);
			BufferedOutputStream bstream = new BufferedOutputStream(fstream, 
					numChannels * numStatisticsTiles * numStatisticsTiles * 4 + 4);// vertices.size()*6*4 + faces.size() * 13);
			DataOutputStream dstream = new DataOutputStream(bstream);				
	
			
			//write description
			dstream.writeInt(numChannels);
			dstream.writeInt(numStatisticsTiles);
			
			
			for(int i = 0; i < numChannels; i++)
				for(int j = 0; j < numStatisticsTiles; j++)
					for(int k = 0; k < numStatisticsTiles; k++){
						InverseCDF icdf = ICDF[i][j][k];
						if(icdf.bins != numBins)
							throw new RuntimeException();
						for(int m = 0; m < numBins; m++){
							dstream.writeFloat(icdf.values[m]);
						}
					}
			dstream.close();
		}		
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	void loadFrom(String file){
		try{
			int fileLength = (int)(new File(file)).length();
			byte fileBytes[] = new byte[fileLength];
			FileInputStream fStream = new FileInputStream(file);
			fStream.read(fileBytes);
			fStream.close();			
			System.out.println("Read file " + file + ", processing..");
			ByteArrayInputStream bStream = new ByteArrayInputStream(fileBytes);
			DataInputStream dstream = new DataInputStream(bStream);
			
			numChannels = dstream.readInt();
			numStatisticsTiles = dstream.readInt();
			
			ICDF = new InverseCDF[numChannels][numStatisticsTiles][numStatisticsTiles];
			System.out.println("  ch: " + numChannels + " tiles: " + 
					numStatisticsTiles + " bins: " + ImageLoader.numBins);				

			
			for(int i = 0; i < numChannels; i++)
				for(int j = 0; j < numStatisticsTiles; j++)
					for(int k = 0; k < numStatisticsTiles; k++){											
						ICDF[i][j][k] = new InverseCDF();
						if(ICDF[i][j][k].bins != ImageLoader.numBins)
							throw new RuntimeException();
						for(int m = 0; m < ImageLoader.numBins; m++){
							ICDF[i][j][k].values[m] = dstream.readFloat();
						}
					}

			dstream.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}		
	}
	
	public static LocalICDF avg(LocalICDF inputs[]){
		int numStatisticsTiles = inputs[0].numStatisticsTiles;
		int numChannels = inputs[0].numChannels;
		for(int i = 0; i < inputs.length; i++)
			if(inputs[i].numStatisticsTiles != numStatisticsTiles ||
					inputs[i].numChannels != numChannels)
				throw new RuntimeException();
		
		LocalICDF result = new LocalICDF(numChannels, numStatisticsTiles);
		for(int i = 0; i < numChannels; i++){
			for(int j = 0; j < numStatisticsTiles; j++){
				for(int k = 0; k < numStatisticsTiles; k++){
					InverseCDF ICDFs[] = new InverseCDF[inputs.length];
					for(int n = 0; n < inputs.length; n++)
						ICDFs[n] = inputs[n].ICDF[i][j][k];
					result.ICDF[i][j][k] = InverseCDF.avg(ICDFs);
				}
			}
		}
			
		return result;
			
	}
	
	public Object[][][] getStats(){
		return ICDF;
	}
	
	public boolean equals(Object o){
		if(!(o instanceof LocalICDF))
			return false;
		else{
			LocalICDF LICDF = (LocalICDF)o;
			if(LICDF.numChannels != numChannels)
				return false;
			if(LICDF.numStatisticsTiles != numStatisticsTiles)
				return false;
			
			for(int i = 0; i < numChannels; i++)
				for(int j = 0; j < numStatisticsTiles; j++)
					for(int k = 0; k < numStatisticsTiles; k++)											
						for(int m = 0; m < ImageLoader.numBins; m++)
							if(ICDF[i][j][k].values[m] != LICDF.ICDF[i][j][k].values[m])
								return false;
			return true;
		}
	}
}
