/*
 * Created on Jun 17, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jogl;

import java.io.*;
import java.util.*;

import javax.vecmath.Vector2d;
import javax.vecmath.Vector2f;
import javax.vecmath.Vector3d;

/**
 * @author golovins
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Mesh {
	static final int LINEAR_SUBDIVISION = 0;
	static final int LOOP_SUBDIVISION = 1;
	static final int BUTTERFLY_SUBDIVISION = 2;
	//static Mesh globalImageMesh;
	
	static final int numBaseVertices = 21;
	
	//Mesh imageMesh;
	
	Grid grid;
	int detailLevel = 0;
	public List vertices;
	public ArrayList faces;
	List markers = new ArrayList();	

	public String meshFile;		
	
	//for each vertex, list of faces
	List vertex2faces;
	List vertex2neighbors = new ArrayList();
		
	float[][] normalTextureX, normalTextureY, normalTextureZ, colorR, colorG, colorB;
	
	TreeSet edgeQueue;
	
	static double [][][]details = new double[0][][]; 
	
	static private Mesh finalImageMesh;
	
	static void initFinalImageMesh(){
		System.out.println("Making final image mesh!");
		finalImageMesh = new Mesh();
		finalImageMesh.makeImageMesh();
		finalImageMesh.saveAs(BatchUtil.dataDir + "markerImageMesh.ply");
		
		finalImageMesh.subdivide(Mesh.LINEAR_SUBDIVISION, true);
		finalImageMesh.subdivide(Mesh.LINEAR_SUBDIVISION, true);

		finalImageMesh.subdivide(Mesh.LOOP_SUBDIVISION, true);
		finalImageMesh.subdivide(Mesh.LOOP_SUBDIVISION, true);
		
		finalImageMesh.subdivide(Mesh.LOOP_SUBDIVISION, true);
		finalImageMesh.subdivide(Mesh.LOOP_SUBDIVISION, true);
		finalImageMesh.subdivide(Mesh.LOOP_SUBDIVISION, true);		
		finalImageMesh.saveAs(BatchUtil.dataDir + "finalImageMesh.ply");
	}
	
	static Mesh getFinalImageMesh(){
		if(finalImageMesh == null)
			initFinalImageMesh();
		return finalImageMesh;
	}
		
	public Mesh(Mesh m){
		detailLevel = m.detailLevel;
		vertices = new ArrayList(m.vertices.size());
		faces = new ArrayList(m.faces.size());
		for(int i = 0; i < m.vertices.size(); i++){
			vertices.add(new Vertex((Vertex)m.vertices.get(i), this));
		}
		for(int i = 0; i < m.faces.size(); i++){
			faces.add(new Face((Face)m.faces.get(i), vertices));
		}
		
		createAdjacency();
		setFaceProperties();
		computeNormals();
		/*
		if(m.imageMesh != null)
			imageMesh = new Mesh (m.imageMesh);
			*/
		
	}
	
	public Mesh(){
		edgeQueue = new TreeSet(new EdgeComparator());
		vertices = new ArrayList();
		faces = new ArrayList(); 
	}
	
	
	public Mesh(String file){
		this();
		this.meshFile = file;

		if(getExtension(file).equals("ply"))
			loadPly(file);
		else if(getExtension(file).equals("vec"))
			loadFromVector(file);
		else
			load(file);
		createAdjacency();
		fillNormals();
		
		int irregularCount = 0;
		for(int i = 0; i < vertices.size(); i++){
			if(((List)vertex2faces.get(i)).size() != 6)
				irregularCount++;
		}
		//System.out.println(irregularCount + " irregular vertices");
		if(file.startsWith("base")){
			setBaseBoundary();
			/*
			if(globalImageMesh == null){
				addPlaneCoords(1);		
				globalImageMesh = imageMesh;
			}
			*/
		}
	}
	
	void fillNormals(){
		Vertex v0 = (Vertex)vertices.get(0);
		if(v0.objNormal != null)
			return;
		computeNormals();
		/*
		for(int i = 0; i < faces.size(); i++){
			Face f = (Face)faces.get(i);
			for(int j = 0; j < 3; j++){
				Vertex v = (Vertex)vertices.get(f.vertices[j]);
				v.objNormal = new Vector3d(f.normal);
			}
		}*/	
	}
	
	void computeNormals(){
		for(int i = 0; i < vertices.size(); i++){
			Vertex v = (Vertex)vertices.get(i);
			v.objNormal = new Vector3d();
		}
		
		
		for(int i = 0; i < faces.size(); i++){
			Face f = (Face)faces.get(i);
			for(int j = 0; j < 3; j++){
				Vertex v = (Vertex)vertices.get(f.vertices[j]);
				v.objNormal.add(f.normal);
			}
		}
		
		for(int i = 0; i < vertices.size(); i++){
			Vertex v = (Vertex)vertices.get(i);
			v.objNormal.normalize();
		}
}
	/*
	void divideLargeEdges(){
		double sum = 0;
		for(int i = 0; i < faces.size(); i++){
			Face f = (Face)faces.get(i);
			for(int j = 0; j < 3; j++){
				sum += f.edgeLengths[j];
			}
		}
		double avgLength = sum / faces.size() / 3;
		System.out.println("Average edge length: " + avgLength);
		divideLargeEdges(avgLength * 1.5);
	}
	*/
	/*
	void divideLargeEdges(double maxEdgeLength){
		System.out.println("Subdividing mesh to a maximum edge length of: " + maxEdgeLength);
		//for(int k = 0; k < 10000; k++){
		
			//System.out.println(edgeQueue.size() +  ": " + edgeQueue);
			//System.out.println();
		int counter = 0;
		while(true){
			Edge e;
			do{
				//System.out.println();
				//if(i > 43)
				//System.out.println(i + ", " + edgeQueue.size() +  ": " + edgeQueue);
				e = (Edge)edgeQueue.first();
				Iterator iter = edgeQueue.iterator();
				iter.next();
				iter.remove();
				//edgeQueue.remove(e);
				//System.out.println(e.face.alive + ": " + e.length);
			}while(!e.face.alive);
			if(e.length < maxEdgeLength)
				break;
			counter++;
			if(counter % 100 == 0)
				System.out.println(counter + ": " + e.length);
			subdivideEdge(e.v1, e.v2);
			//System.out.println(i + ", " + edgeQueue.size() +  ": " + edgeQueue);
		}	
		System.out.println("Removing dead faces");
		ArrayList newFaceList = new ArrayList();
		for(int i = 0; i < faces.size(); i++){
			if(((Face)faces.get(i)).alive){
				newFaceList.add(faces.get(i));
			}
		}
		faces = newFaceList;
		
		System.out.println("Edge queue size: " + edgeQueue.size());
		System.out.println("Number of subdivisions performed: " + counter);
		System.out.println("New number of vertices: " + vertices.size());
		System.out.println("New number of faces: " + faces.size());
	}
	*/
	void printInfo(){
		System.out.println("Face list:");
		for(int i = 0; i < faces.size(); i++){
			for(int j = 0; j < 3; j++)
				System.out.print(((Face)faces.get(i)).vertices[j] + " ");
			System.out.println();
		}
		System.out.println("Vertex to face adjacency list:");
		for(int i = 0; i < vertex2faces.size(); i++){
			List list = (List)vertex2faces.get(i);
			for(int j = 0; j < list.size(); j++){
				Face f = (Face)list.get(j);
				int faceIndex = faces.indexOf(f);
				System.out.print(faceIndex + " ");				
			}		
			System.out.println();
		}
	}
	
	void deleteMarkedVertices(){
		int numDeleted = 0;
		for(int i = 0; i < vertices.size(); i++){
			Vertex v = (Vertex)vertices.get(i);
			if(v.markedForDeletion){
				vertices.remove(i);
				numDeleted++;
				i--;
			}
			v.index -= numDeleted;
		}
		
		for(int i = 0; i < faces.size(); i++){
			Face f = (Face)faces.get(i);
			for(int j = 0; j < 3; j++){
				if(f.verts[j].markedForDeletion){
					faces.remove(i);
					i--;
					break;
				}
				f.vertices[j] = f.verts[j].index;
			}
		}
	}
	
	void createAdjacency(){
		vertex2neighbors = new ArrayList(vertices.size());
		vertex2faces = new ArrayList(vertices.size());
		for(int i = 0; i < vertices.size(); i++){
			vertex2faces.add(new ArrayList());
			vertex2neighbors.add(new ArrayList());
			Vertex v = (Vertex)vertices.get(i);
			v.faces = (List)vertex2faces.get(i);
			v.neighbors = (List)vertex2neighbors.get(i);
			v.index = i;
		}
		for(int i = 0; i < faces.size(); i++){
			Face f = (Face)faces.get(i);
			((List)vertex2faces.get(f.vertices[0])).add(f);
			((List)vertex2faces.get(f.vertices[1])).add(f);
			((List)vertex2faces.get(f.vertices[2])).add(f);
			
			for(int j = 0; j < 3; j++){
				Vertex upNeighbor = (Vertex)vertices.get(f.vertices[(j + 1) %3]);
				Vertex downNeighbor = (Vertex)vertices.get(f.vertices[(j + 2) %3]);
				List neighbors = ((List)vertex2neighbors.get(f.vertices[j])); 
				if(!neighbors.contains(upNeighbor))
					neighbors.add(upNeighbor);
				if(!neighbors.contains(downNeighbor))
					neighbors.add(downNeighbor);				
			}
		}	
	}
	
	/*
	void subdivideEdge(int v1, int v2){
		if(v1 == v2)
			throw new RuntimeException("invalid edge for subdivision");
		
		Vertex newVertex = Vertex.avg((Vertex)vertices.get(v1), (Vertex)vertices.get(v2)); 
		int newVert = vertices.size();
		vertices.add(newVertex);
		List newVertexFaceList = new ArrayList();
		vertex2faces.add(newVertexFaceList);
		
		List v1Faces = (List)vertex2faces.get(v1);
		List v2Faces = (List)vertex2faces.get(v2);
		List edgeFaces = new ArrayList(v1Faces);
		
		edgeFaces.retainAll(v2Faces);
		v1Faces.removeAll(edgeFaces);
		v2Faces.removeAll(edgeFaces);
		//System.out.println("Found " + edgeFaces.size() + " faces along the edge");
		for(int i = 0; i < edgeFaces.size(); i++){
			Face face = (Face)edgeFaces.get(i);
			//System.out.println("Face being divided: " + face.vertices[0] + " " + face.vertices[1] + " " + face.vertices[2]);
			//faces.remove(face);
			face.alive = false;
			//vertices and lists in proper order
			int vert1 = v1;
			int vert2 = v2;
			List vert1Faces = v1Faces;
			List vert2Faces = v2Faces;
			int vert1Index = 0, vert2Index = 0;			
			int oppositeVertex = 0;
			for(int j = 0; j < 3; j++){
				if(face.vertices[j] == v1)
					vert1Index = j;
				else if(face.vertices[j] == v2)
					vert2Index = j;
				else
					oppositeVertex = face.vertices[j];
			}
			//System.out.println(vert1Index + " " + vert2Index +  "; " + oppositeVertex);
			if(vert2Index != ((vert1Index + 1) % 3)){
				//vertices not clockwise
				vert2 = v1;
				vert1 = v2;
				vert1Faces = v2Faces;
				vert2Faces = v1Faces;
			}				
			
			Face newFace1 = new Face(oppositeVertex, newVert, vert2, vertices, edgeQueue);
			Face newFace2 = new Face(oppositeVertex, vert1, newVert, vertices, edgeQueue);
			faces.add(newFace1);
			faces.add(newFace2);
			newVertexFaceList.add(newFace1);
			newVertexFaceList.add(newFace2);
			
			vert1Faces.add(newFace2);
			vert2Faces.add(newFace1);
			
			List oppositeEdgeFaces = (List)vertex2faces.get(oppositeVertex);
			oppositeEdgeFaces.remove(face);
			oppositeEdgeFaces.add(newFace1);
			oppositeEdgeFaces.add(newFace2);
			//System.out.println();
			//printInfo();
		}
	}
	*/
	/*
	void subdivideTriangle(int faceIndex, Hashtable edgeToVerts, List newFaces){
		Face f = (Face)faces.get(faceIndex);
		
		Vertex v0 = (Vertex)vertices.get(f.vertices[0]);
		Vertex v1 = (Vertex)vertices.get(f.vertices[1]);
		Vertex v2 = (Vertex)vertices.get(f.vertices[2]);
	
		int vert0 = f.vertices[0];
		int vert1 = f.vertices[1];
		int vert2 = f.vertices[2];
				
		Vertex v3;
		EdgeInt v3Edge = new EdgeInt(v0.index, v1.index);
		if(edgeToVerts.containsKey(v3Edge))
			v3 = (Vertex)edgeToVerts.get(v3Edge);
		else{
			v3 = Vertex.avg(v0, v1);
			v3.index = vertices.size();
			vertices.add(v3);
			edgeToVerts.put(v3Edge, v3);
		}

		Vertex v4;
		EdgeInt v4Edge = new EdgeInt(v1.index, v2.index);
		if(edgeToVerts.containsKey(v4Edge))
			v4 = (Vertex)edgeToVerts.get(v4Edge);
		else{
			v4 = Vertex.avg(v1, v2);
			v4.index = vertices.size();
			vertices.add(v4);
			edgeToVerts.put(v4Edge, v4);
		}

		Vertex v5;
		EdgeInt v5Edge = new EdgeInt(v2.index, v0.index);
		if(edgeToVerts.containsKey(v5Edge)){
			v5 = (Vertex)edgeToVerts.get(v5Edge);
		}
		else{
			v5 = Vertex.avg(v2, v0);
			v5.index = vertices.size();
			vertices.add(v5);
			edgeToVerts.put(v5Edge, v5);
		}
		
		int vert3 = v3.index;
		int vert4 = v4.index;
		int vert5 = v5.index;

		newFaces.add(new Face(vert0, vert3, vert5, vertices, edgeQueue));
		newFaces.add(new Face(vert3, vert1, vert4, vertices, edgeQueue));
		newFaces.add(new Face(vert5, vert3, vert4, vertices, edgeQueue));
		newFaces.add(new Face(vert5, vert4, vert2, vertices, edgeQueue));
	}*/
	
	void setPosLoop(Vertex v, Vertex v0, Vertex v1, Vertex v2){
		if(v.boundary)
			return;
		
		List v0faces = new ArrayList(v0.faces);
		v0faces.retainAll(v1.faces);
		if(v0faces.size() > 2)
			throw new RuntimeException("v0 faces size: " + v0faces.size());
		Vertex v4 = null;
		for(int i = 0; i < v0faces.size(); i++){
			Face f = (Face)v0faces.get(i);
			for(int j = 0; j < f.verts.length; j++){
				if(f.verts[j].index != v0.index && f.verts[j].index != v1.index &&
					f.verts[j].index != v2.index){
					v4 = f.verts[j];
					break;
				}
			}
		}
		//System.out.println("v4: " + v4);
		if(v4 == null){
			//System.out.println("  extraordinary vertex, between " + v0 + " and " + v1);
			return;
		}
		
		v.pos.set(0, 0, 0);
		v.pos.scaleAdd(3.0/8, v0.pos, v.pos);
		v.pos.scaleAdd(3.0/8, v1.pos, v.pos);
		v.pos.scaleAdd(1.0/8, v2.pos, v.pos);
		v.pos.scaleAdd(1.0/8, v4.pos, v.pos);
	}

	Vertex findOpposite(Vertex v0, Vertex v1, Vertex v2){
		/*
		System.out.println(v0.faces);
		System.out.println(v1);
		System.out.println(v1.faces);
		*/
		List v0faces = new ArrayList(v0.faces);
		v0faces.retainAll(v1.faces);
		if(v0faces.size() > 2)
			throw new RuntimeException("v0 faces size: " + v0faces.size());
		Vertex v4 = null;
		for(int i = 0; i < v0faces.size(); i++){
			Face f = (Face)v0faces.get(i);
			for(int j = 0; j < f.verts.length; j++){
				if(f.verts[j].index != v0.index && f.verts[j].index != v1.index &&
					f.verts[j].index != v2.index){
					v4 = f.verts[j];
					break;
				}
			}
		}
		
		if(v4 != null)
			return v4;
		else{
			Vector3d result = new Vector3d();
			result.add(v0.pos, v1.pos);
			result.scale(.5);
			result.sub(result, v2.pos);
			result.scaleAdd(2, result, v2.pos);
			return new Vertex(null, result);
		}			
	}
	
	Vertex findNeighborOnBoundary(Vertex v0, Vertex v1){
		ArrayList v0Neighbors = new ArrayList(v0.neighbors);
		Vertex v3 = null;
		ArrayList v0boundaryList = new ArrayList();
		for(int i = 0; i < v0Neighbors.size(); i++){
			Vertex vert = (Vertex)v0Neighbors.get(i);
			if(vert != v1 && vert.boundary){
				v0boundaryList.add(vert);
			}
		}			
		if(v0boundaryList.size() != 1)
			throw new RuntimeException("Boundary list is: " + v0boundaryList);
		v3 = (Vertex)v0boundaryList.get(0);
		return v3;
	}
	double getButterflyExtraordinaryCoefficient(int i, int size){
		if(size == 3){
			if(i == 0) return 5.0/12;
			else return -1.0/12; 
		}
		else if(size == 4){
			if(i == 0) return 3.0/8;
			else if(i == 2) return -1.0/8;
			else return 0;
		}
		else{
			return 1.0/size * (.25 + Math.cos(2 * i * Math.PI / size) + .5 * Math.cos(4 * i * Math.PI / size));
		}
	}
	
	Vector3d getButterflyExtraordinaryInterior(Vertex v0, Vertex v1, Vertex v2){
		System.out.println("finding extraordinary pos: " + v0 + ", " + v1 + "; " + v2);
		ArrayList v0Ring = new ArrayList();
		v0Ring.add(v1);
		Vertex prevNeighbor = v1;
		Vertex prevPrevNeighbor = v2;
		Vertex nextNeighbor = null;
		while(nextNeighbor != v2){
			nextNeighbor = findOpposite(v0, prevNeighbor, prevPrevNeighbor);			
			System.out.println("next neighbor: " + nextNeighbor);
			v0Ring.add(nextNeighbor);
			prevPrevNeighbor = prevNeighbor;
			prevNeighbor = nextNeighbor;
		}
		if(v0Ring.size() != v0.neighbors.size())
			throw new RuntimeException("Found v0 ring incorrectly");
		
		Vector3d newPos = new Vector3d(v0.pos);
		newPos.scale(3.0/4);
		//Vector3d diff = new Vector3d();
		for(int i = 0; i < v0Ring.size(); i++){
			Vertex neighbor = (Vertex)v0Ring.get(i);
			//diff.sub(neighbor.pos, v0.pos);
			double coefficient = getButterflyExtraordinaryCoefficient(i, v0Ring.size());
			newPos.scaleAdd(coefficient, neighbor.pos, newPos);
		}
		return newPos;
	}
	
	void setPosButterfly(Vertex v, Vertex v0, Vertex v1, Vertex v2){				
		if(v.boundary){
			Vertex v3 = findNeighborOnBoundary(v0, v1);
			Vertex v4 = findNeighborOnBoundary(v1, v0);						
			
			v.pos.set(0, 0, 0);
			v.pos.scaleAdd(9.0/16, v0.pos, v.pos);
			v.pos.scaleAdd(9.0/16, v1.pos, v.pos);
			v.pos.scaleAdd(-1.0/16, v3.pos, v.pos);
			v.pos.scaleAdd(-1.0/16, v4.pos, v.pos);
			
			return;
		}
		
		/*
		System.out.println(v0 + " " + v1);
		if(v0.neighbors.size() == 6 && v1.neighbors.size() == 6){
			System.out.println("regular - regular");
		}
		else if(v0.neighbors.size() != 6 && v1.neighbors.size() != 6){
			System.out.println("irregular - irregular");
		}
		else
			System.out.println("irregular - regular");
		*/

		Vector3d v0extraordinary = null;
		boolean v0Extra = false;
		if(v0.neighbors.size() != 6 && !v0.boundary){ //interior extraordinary
			v0Extra = true;
			v0extraordinary = getButterflyExtraordinaryInterior(v0, v1, v2);
		}
		Vector3d v1extraordinary = null;
		boolean v1Extra = false;
		if(v1.neighbors.size() != 6 && !v1.boundary){ //interior extraordinary
			v1Extra = true;
			v1extraordinary = getButterflyExtraordinaryInterior(v1, v0, v2);
		}
		if(v0Extra && v1Extra) //interior extraordinary - interior extraordinary
			v.pos.interpolate(v0extraordinary, v1extraordinary, .5);					
		else if(v0Extra)
			v.pos.set(v0extraordinary);
		else if(v1Extra)
			v.pos.set(v1extraordinary);
		else{ //regular-regular (hopefully)
			Vertex v4 = findOpposite(v0, v1, v2);
			Vertex v5 = findOpposite(v0, v2, v1);
			Vertex v6 = findOpposite(v2, v1, v0);
			Vertex v7 = findOpposite(v0, v4, v1);
			Vertex v8 = findOpposite(v4, v1, v0);
			//System.out.println(v0 + " " + v1 + " " + v2 + ": " + v4 + " " + v5 + " " + v6 + " " + v7 + " " + v8);
			
			if(v4 == null || v5 == null || v6 == null || v7 == null || v8 == null){ //near border						
				System.out.println("Butterfly subdivision unsuccessful, probably near border: " + v0 + " " + v1);
				return;
			}
			
			v.pos.set(0, 0, 0);
			v.pos.scaleAdd(1.0/2, v0.pos, v.pos);
			v.pos.scaleAdd(1.0/2, v1.pos, v.pos);
			v.pos.scaleAdd(1.0/8, v2.pos, v.pos);
			v.pos.scaleAdd(1.0/8, v4.pos, v.pos);
	
			v.pos.scaleAdd(-1.0/16, v5.pos, v.pos);
			v.pos.scaleAdd(-1.0/16, v6.pos, v.pos);
			v.pos.scaleAdd(-1.0/16, v7.pos, v.pos);
			v.pos.scaleAdd(-1.0/16, v8.pos, v.pos);
		}
	}	
	
	void subdivideTriangle(int subdivisionType, int faceIndex, Hashtable edgeToVerts, List newFaces, boolean holdBoundary){
		Face f = (Face)faces.get(faceIndex);
		
		Vertex v0 = (Vertex)vertices.get(f.vertices[0]);
		Vertex v1 = (Vertex)vertices.get(f.vertices[1]);
		Vertex v2 = (Vertex)vertices.get(f.vertices[2]);
	
		int vert0 = f.vertices[0];
		int vert1 = f.vertices[1];
		int vert2 = f.vertices[2];
				
		Vertex v3;
		EdgeInt v3Edge = new EdgeInt(v0.index, v1.index);
		if(edgeToVerts.containsKey(v3Edge))
			v3 = (Vertex)edgeToVerts.get(v3Edge);
		else{
			v3 = Vertex.avg(v0, v1);
			v3.index = vertices.size();
			vertices.add(v3);
			edgeToVerts.put(v3Edge, v3);
			if(v3.boundary && holdBoundary){
				
			}
			else if(subdivisionType == LOOP_SUBDIVISION)
				setPosLoop(v3, v0, v1, v2);
			else if(subdivisionType == BUTTERFLY_SUBDIVISION)
				setPosButterfly(v3, v0, v1, v2);
		}

		Vertex v4;
		EdgeInt v4Edge = new EdgeInt(v1.index, v2.index);
		if(edgeToVerts.containsKey(v4Edge))
			v4 = (Vertex)edgeToVerts.get(v4Edge);
		else{
			v4 = Vertex.avg(v1, v2);
			v4.index = vertices.size();
			vertices.add(v4);
			edgeToVerts.put(v4Edge, v4);
			if(v4.boundary && holdBoundary){
				
			}
			else if(subdivisionType == LOOP_SUBDIVISION)
				setPosLoop(v4, v1, v2, v0);
			else if(subdivisionType == BUTTERFLY_SUBDIVISION)
				setPosButterfly(v4, v1, v2, v0);
		}

		Vertex v5;
		EdgeInt v5Edge = new EdgeInt(v2.index, v0.index);
		if(edgeToVerts.containsKey(v5Edge)){
			v5 = (Vertex)edgeToVerts.get(v5Edge);
		}
		else{
			v5 = Vertex.avg(v2, v0);
			v5.index = vertices.size();
			vertices.add(v5);
			edgeToVerts.put(v5Edge, v5);
			if(v5.boundary && holdBoundary){
				
			}
			else if(subdivisionType == LOOP_SUBDIVISION)
				setPosLoop(v5, v2, v0, v1);
			else if(subdivisionType == BUTTERFLY_SUBDIVISION)
				setPosButterfly(v5, v2, v0, v1);
		}
		
		int vert3 = v3.index;
		int vert4 = v4.index;
		int vert5 = v5.index;

		newFaces.add(new Face(vert0, vert3, vert5, vertices, edgeQueue));
		newFaces.add(new Face(vert3, vert1, vert4, vertices, edgeQueue));
		newFaces.add(new Face(vert5, vert3, vert4, vertices, edgeQueue));
		newFaces.add(new Face(vert5, vert4, vert2, vertices, edgeQueue));
	}
	
	
	/*
	void loopSubdivideTriangle(int faceIndex, Hashtable edgeToVerts, List newFaces){
		Face f = (Face)faces.get(faceIndex);
		
		Vertex v0 = (Vertex)vertices.get(f.vertices[0]);
		Vertex v1 = (Vertex)vertices.get(f.vertices[1]);
		Vertex v2 = (Vertex)vertices.get(f.vertices[2]);
	
		int vert0 = f.vertices[0];
		int vert1 = f.vertices[1];
		int vert2 = f.vertices[2];
				
		Vertex v3;
		EdgeInt v3Edge = new EdgeInt(v0.index, v1.index);
		if(edgeToVerts.containsKey(v3Edge))
			v3 = (Vertex)edgeToVerts.get(v3Edge);
		else{
			v3 = Vertex.avg(v0, v1);
			v3.index = vertices.size();
			vertices.add(v3);
			edgeToVerts.put(v3Edge, v3);
			setPosLoop(v3, v0, v1, v2);
		}

		Vertex v4;
		EdgeInt v4Edge = new EdgeInt(v1.index, v2.index);
		if(edgeToVerts.containsKey(v4Edge))
			v4 = (Vertex)edgeToVerts.get(v4Edge);
		else{
			v4 = Vertex.avg(v1, v2);
			v4.index = vertices.size();
			vertices.add(v4);
			edgeToVerts.put(v4Edge, v4);
			setPosLoop(v4, v1, v2, v0);
		}

		Vertex v5;
		EdgeInt v5Edge = new EdgeInt(v2.index, v0.index);
		if(edgeToVerts.containsKey(v5Edge)){
			v5 = (Vertex)edgeToVerts.get(v5Edge);
		}
		else{
			v5 = Vertex.avg(v2, v0);
			v5.index = vertices.size();
			vertices.add(v5);
			edgeToVerts.put(v5Edge, v5);
			setPosLoop(v5, v2, v0, v1);
		}
		
		int vert3 = v3.index;
		int vert4 = v4.index;
		int vert5 = v5.index;

		newFaces.add(new Face(vert0, vert3, vert5, vertices, edgeQueue));
		newFaces.add(new Face(vert3, vert1, vert4, vertices, edgeQueue));
		newFaces.add(new Face(vert5, vert3, vert4, vertices, edgeQueue));
		newFaces.add(new Face(vert5, vert4, vert2, vertices, edgeQueue));
	}*/

	void subdivide(int subdivisionType){
		subdivide(subdivisionType, false);
	}
	
	void subdivide(int subdivisionType, boolean holdBoundary){
		Hashtable edgeToVerts = new Hashtable();
		int numFaces = faces.size();
		int prevNumVerts = vertices.size();
		ArrayList newFaces = new ArrayList(numFaces * 4);
		
		for(int i = 0; i < numFaces; i++){
			if(i % 50000 == 0)
				System.out.println("    subdividing face " + i);
			subdivideTriangle(subdivisionType, i, edgeToVerts, newFaces, holdBoundary);
			//System.out.println("Did a face subdivision");
			//System.out.println(edgeToVerts.keySet());
			
		}
		faces.clear();
		faces = newFaces;
		
		if(subdivisionType == LOOP_SUBDIVISION){
			for(int i = 0; i < prevNumVerts; i++){
				Vertex v = (Vertex)vertices.get(i);				
				if(v.newPos == null)
					v.newPos = new Vector3d();
				if(false /*v.baseVertex*/){
					v.newPos.set(v.pos);
				}
				else{
					if(v.boundary){
						if(holdBoundary){
							v.newPos.set(v.pos);
						}
						else{
							v.newPos.set(0, 0, 0);
							v.newPos.scaleAdd(3.0/4, v.pos, v.newPos);
							int numBoundaryNeighbors = 0;
							for(int j = 0; j < v.neighbors.size(); j++){
								Vertex neighbor = (Vertex)v.neighbors.get(j);
								if(neighbor.boundary){
									numBoundaryNeighbors++;
									v.newPos.scaleAdd(1.0/8, neighbor.pos, v.newPos);
									
								}						
							}
							if(numBoundaryNeighbors != 2){
								System.out.println("PROBLEM: NOT 2 BOUNDARY NEIGHBORS");
							}
						}
					}
					else{
						int numNeighbors = v.neighbors.size();
						double weight = 3.0/(8 * numNeighbors);
						if(numNeighbors == 3)
							weight = 3.0/16;
						v.newPos.set(v.pos);
						v.newPos.scale(1 - weight * numNeighbors);
						for(int j = 0; j < numNeighbors; j++){
							Vertex neighbor = (Vertex)v.neighbors.get(j);
							v.newPos.scaleAdd(weight, neighbor.pos, v.newPos);
						}
						//v.pos.set(v.newPos);
					}
				}
			}
			for(int i = 0; i < prevNumVerts; i++){
				Vertex v = (Vertex)vertices.get(i);
				v.pos.set(v.newPos);
			}
		}		
		createAdjacency();
		computeNormals();
		
		/*
		if(imageMesh != null)
			imageMesh.subdivide(subdivisionType, true);
		*/
		//detailLevel++;
	}
	/*
	void subdivide(){
		Hashtable edgeToVerts = new Hashtable();
		int numFaces = faces.size();
		ArrayList newFaces = new ArrayList(numFaces * 4);
		
		for(int i = 0; i < numFaces; i++){
			if(i % 50000 == 0)
				System.out.println("    subdividing face " + i);
			subdivideTriangle(i, edgeToVerts, newFaces);
			//System.out.println("Did a face subdivision");
			//System.out.println(edgeToVerts.keySet());
			
		}
		faces.clear();
		faces = newFaces;
		createAdjacency();
		computeNormals();
		//detailLevel++;
	}*/
	
	Vertex vertexAt(Vector3d pos){
		Vector3d diff = new Vector3d();
		for(int i = 0; i < vertices.size(); i++){
			Vertex v = (Vertex)vertices.get(i);
			diff.sub(v.pos, pos);
			if(diff.length() < .000001)
				return v;
		}
		return null;		
	}
	
	public String toString(){
		return "faces: " + faces.size() + ", vertices: " + vertices.size();	
	}
	
	/*
	void divideLargeTriangles(){
		double areaSum = 0;
		for(int i = 0; i < faces.size(); i++){
			Face f = (Face)faces.get(i);
			areaSum += f.area;
		}
		
		double avgArea = areaSum / faces.size();
		System.out.println("Avg triangle area: " + avgArea);
		int numLargeFaces = 0;
		for(int i = 0; i < faces.size(); i++){
			Face f = (Face)faces.get(i);
			if(f.area > 6 * avgArea){
				subdivideTriangle(LINEAR_SUBDIVISION, i, null, null, false); //will cause exception, fix later if necessary
				numLargeFaces++;
				i--;
			}
		}
		System.out.println("Number of triangles subdivided: " + numLargeFaces);		
	
	}
	*/
	public static String getExtension(String file){
		return file.substring(file.lastIndexOf('.') + 1);	
	}
	
	public boolean extraNormals(){
		Vertex v0 = (Vertex)vertices.get(0);
		return v0.photoNormal != null;
	}
	
	public void saveAs(String fileName){
		String extension = Mesh.getExtension(fileName);
		if(extension.equals("ply")){
			savePly(fileName, true);
		}
		else if(extension.equals("vec")){
			saveAsVector(fileName);
		}
		else if(extension.equals("obj")){
			saveObj(fileName, false);
		}
	}
	
	public void savePly(String file, boolean binary){
		try{
			System.out.println("Converting to " + file);
			FileWriter writer = new FileWriter(file);
			writer.write("ply\n");
			if(binary)			
				writer.write("format binary_big_endian 1.0\n");
			else
				writer.write("format ascii 1.0\n");
			writer.write("comment made by Aleksey Golovinskiy, MERL\n");
			writer.write("comment face scan\n");
			writer.write("element vertex " + vertices.size() + "\n");
			writer.write("property float x\n");
			writer.write("property float y\n");
			writer.write("property float z\n");
			if(extraNormals()){
				writer.write("property float nx\n");
				writer.write("property float ny\n");
				writer.write("property float nz\n");
			}
			writer.write("element face " + faces.size() + "\n");
			writer.write("property list uchar int vertex_indices\n");
			writer.write("end_header\n");
			char[] intChar = new char[4];
			if(binary){
				writer.close();
				FileOutputStream fstream = new FileOutputStream(file, true);
				BufferedOutputStream bstream = new BufferedOutputStream(fstream, vertices.size()*6*4 + faces.size() * 13);
				DataOutputStream dstream = new DataOutputStream(bstream);				
				System.out.println("Writing vertices...");
				for(int i = 0; i < vertices.size(); i++){
					/*
					if(i % 10000 == 0)
						System.out.println(i);
						*/
					Vertex v = (Vertex)vertices.get(i);
					dstream.writeFloat((float)v.pos.x);
					dstream.writeFloat((float)v.pos.y);
					dstream.writeFloat((float)v.pos.z);					
					if(extraNormals()){
						dstream.writeFloat((float)v.photoNormal.x);
						dstream.writeFloat((float)v.photoNormal.y);
						dstream.writeFloat((float)v.photoNormal.z);
					}
				}
				System.out.println("Writing faces...");
				for(int i = 0; i < faces.size(); i++){
					/*
					if(i % 10000 == 0)
						System.out.println(i);
					*/
					dstream.writeByte(3);
					Face f = (Face)faces.get(i);
					dstream.writeInt(f.vertices[0]);
					dstream.writeInt(f.vertices[1]);
					dstream.writeInt(f.vertices[2]);
				}
				System.out.println("Writing to file...");
				dstream.close();
				System.out.println("File saved: " + file);
			}
			else{
				for(int i = 0; i < vertices.size(); i++){
					Vertex v = (Vertex)vertices.get(i);
					writer.write(v.pos.x + "  " + v.pos.y + "  " + v.pos.z + "  ");
					writer.write(v.photoNormal.x + "  " + v.photoNormal.y + "  " + v.photoNormal.z + "\n");
				}
				for(int i = 0; i < faces.size(); i++){
					Face f = (Face)faces.get(i);
					writer.write(3 + "  " + f.vertices[0] + "  " + f.vertices[1] + "  " + f.vertices[2] + "\n");
				}
				writer.close();
			}
		}
		catch(IOException e){			
			System.out.println(e);
		}
	}
	
	private int reverse(int b){
		/*
		int output = 0;
		for(int i = 0; i < 32; i++){
			
			output = (output | (((b >> (31 - i)) & 1) << i));
			System.out.println((b >> (31 - i)) & 1);
		}*/
		System.out.println(Integer.toBinaryString(b));
		return b;
	}
	
	
	private int readInt(DataInputStream dstream) throws IOException{
		//return reverse(dstream.readInt());
		
		
		byte d = dstream.readByte();		
		byte c = dstream.readByte();
		byte b = dstream.readByte();
		byte a = dstream.readByte();
		//System.out.println(d + ", " + c + ", " + b + ", " + a);
		//d = reverse(d);
		
		return (((a & 0xff) << 24) | ((b & 0xff) << 16) |
		 		  ((c & 0xff) << 8) | (d & 0xff));
		 		  
	}
	
	float[][] loadTexture(String file) throws IOException{
		DataInputStream dstream = new DataInputStream(new FileInputStream(file));
		/*
		for(int i = 0; i < 1; i++){
			System.out.println();
			for(int j = 0; j < 4; j++)
				System.out.print(dstream.readByte() + " ");
		}*/
		//System.out.println(readInt(dstream));
		//System.out.println(readInt(dstream));
		System.out.println("Version: " + readInt(dstream));
		int rows = readInt(dstream);
		int cols = readInt(dstream);
		System.out.println("Size: " + rows + " x " + cols + ", reading...");		
		float texture[][] = new float[rows][cols];
		byte byteArray[] = new byte[rows*cols * 4];
		dstream.read(byteArray);
		byte a, b, c, d;
		int index = 0;
		for(int i = 0; i < rows; i++){
//			if(i%100 == 0)
				//System.out.println(i);
			for(int j = 0; j < cols; j++){
				//System.out.println(i + ", " + j + " -> " + index);
				a = byteArray[index + 3];
				b = byteArray[index + 2];
				c = byteArray[index + 1];
				d = byteArray[index + 0];
				int intRep = (((a & 0xff) << 24) | ((b & 0xff) << 16) |
				 		  ((c & 0xff) << 8) | (d & 0xff));
				texture[j][i] = Float.intBitsToFloat(intRep);
				index += 4;				
			}
		}
		//System.out.println(texture[0][0]);
		return texture;
	}
	
	Vector3d[] loadVectors(String file) throws IOException{
		int fileLength = (int)(new File(file)).length();
		char fileBytes[] = new char[fileLength];
		(new FileReader(file)).read(fileBytes);
		BufferedReader reader = new BufferedReader(new CharArrayReader(fileBytes));		
		
		Vector3d[] output = new Vector3d[vertices.size()];
		for(int i = 0; i < output.length; i++){
			String line = reader.readLine();
			StringTokenizer tokenizer = new StringTokenizer(line);
			double x = Double.parseDouble(tokenizer.nextToken());
			double y = Double.parseDouble(tokenizer.nextToken());
			double z = Double.parseDouble(tokenizer.nextToken());
			output[i] = new Vector3d(x, y, z);
		}
		return output;
	}
	
	public static double textureValue(double x, double y, float[][] texture){
		int xInt = (int)(x * texture.length);
		int yInt = (int)(y * texture[0].length);	        		
		
		double xRemainder = x * texture.length - xInt;
		double yRemainder = y * texture[0].length - yInt;
		
		double downLeft = texture[xInt][yInt];
		double downRight = texture[xInt + 1][yInt];
		double upLeft = texture[xInt][yInt + 1];
		double upRight = texture[xInt + 1][yInt + 1];
		
		double left = downLeft * (1 - yRemainder) + upLeft * yRemainder;
		double right = downRight * (1 - yRemainder) + upRight * yRemainder;
	
		return left * (1 - xRemainder) + right * xRemainder;
	}
	
	public void loadTextures(String normalXfile, String normalYfile, String normalZfile) throws IOException{
		
		
		Vertex v0 = (Vertex)vertices.get(0);
		if(v0.textureCoords == null){
			System.out.println("Texture coordinates not in file, texture not loading");
			return;
		}
		System.out.println("Loading normal X map..");
		normalTextureX = loadTexture(normalXfile /*"60_coeff-tex-nx-1024.flt"*/);
		System.out.println("Loading normal Y map..");
		normalTextureY = loadTexture(normalYfile /*"60_coeff-tex-ny-1024.flt"*/);
		System.out.println("Loading normal Z map..");
		normalTextureZ = loadTexture(normalZfile /*"60_coeff-tex-nz-1024.flt"*/);			
		
		/*
		System.out.println("Loading color texture R...");
		colorR = loadTexture("coeff-tex-ar-1024.flt");
		System.out.println("Loading color texture G...");
		colorG = loadTexture("coeff-tex-ag-1024.flt");
		System.out.println("Loading color texture B...");
		colorB = loadTexture("coeff-tex-ab-1024.flt");
		*/
		//System.out.println("First color: " + colorR[0][0] + ", " + colorG[0][0] + ", " + colorB[0][0]);
		
		for(int i = 0; i < vertices.size(); i++){
			Vertex v = (Vertex)vertices.get(i);
			v.loadTextureValues();			
		}
		/*
		System.out.println("Loading normals...");
		Vector3d[] photoNormals = loadVectors("s905-050106-02-registered-uv-nrml.txt"); 
		System.out.println("Loading albedo...");
		Vector3d[] colors = loadVectors("s905-050106-02-registered-uv-colors.txt");
		for(int i = 0; i < vertices.size(); i++){
			Vertex v = (Vertex)vertices.get(i);
			v.photoNormal = photoNormals[i];			
			v.color = colors[i];		
		}		
		
		for(int i = 300; i < 2000; i++){
			Vertex v = (Vertex)vertices.get(i);
			Vector3d diff = new Vector3d();
			diff.sub(v.objNormal, v.photoNormal);
			System.out.println(v.photoNormal + "; diff: " + diff.length());			
		}
		
		double maxDiff = 0;
		for(int i = 0; i < vertices.size(); i++){
			Vertex v = (Vertex)vertices.get(i);
			Vector3d diff = new Vector3d();
			diff.sub(v.objNormal, v.photoNormal);
			double diffLength = diff.length();
			if(diffLength > maxDiff)
				maxDiff = diffLength;
		}
		System.out.println("max diff: " + maxDiff);
		*/
	}
	
	void loadOBJ(String file) throws IOException{
		int textureCounter = 0, normalCounter = 0;
		System.out.println("Reading input mesh: " + file);
		int fileLength = (int)(new File(file)).length();
		char fileBytes[] = new char[fileLength];
		FileReader fReader = new FileReader(file);
		fReader.read(fileBytes);
		fReader.close();
		
		System.out.println("Read file, processing..");
		BufferedReader reader = new BufferedReader(new CharArrayReader(fileBytes));
		while(true){
			String line = reader.readLine();
			if(line == null)
				break;
			//System.out.println();
			StringTokenizer tokenizer = (new StringTokenizer(line));
			if(!tokenizer.hasMoreTokens())
				continue;
			String element = tokenizer.nextToken();
			
			if(element.equals("f")){
				Face f = new Face(line, vertices, edgeQueue);
				faces.add(f);				
			}
			
			else if(element.equals("v")){
				//System.out.println("vertex " + vertices.size());
				Vertex v = new Vertex(this, line);
				vertices.add(v);
			}			
			else if(element.equals("vt")){
				//System.out.println("texture coord: " + textureCounter);
				Vertex v = (Vertex)vertices.get(textureCounter);
				v.loadTextureCoords(line);					
				textureCounter++;
			}
			else if(element.equals("vn")){
				Vertex v = (Vertex)vertices.get(normalCounter);
				v.loadNormal(line);					
				normalCounter++;
			}
		}	
	}
	
	void loadPositions(String file) throws IOException{
		System.out.println("Reading positions: " + file);
		int fileLength = (int)(new File(file)).length();
		char fileBytes[] = new char[fileLength];
		(new FileReader(file)).read(fileBytes);
		System.out.println("Read positions file, processing..");
		BufferedReader reader = new BufferedReader(new CharArrayReader(fileBytes));
		while(true){					
			String line = reader.readLine();
			if(line == null)
				break;
			StringTokenizer tokenizer = (new StringTokenizer(line));
			if(!tokenizer.hasMoreTokens())
				continue;
			double x = Double.parseDouble(tokenizer.nextToken());
			double y = Double.parseDouble(tokenizer.nextToken());
			double z = Double.parseDouble(tokenizer.nextToken());
			vertices.add(new Vertex(this, x, y, z));					
		}		
	}
	
	void loadUV(String file) throws IOException{
		int index = 0;
		System.out.println("Reading uv file: " + file);
		int fileLength = (int)(new File(file)).length();
		char fileBytes[] = new char[fileLength];
		(new FileReader(file)).read(fileBytes);
		System.out.println("Read uv file, processing..");
		BufferedReader reader = new BufferedReader(new CharArrayReader(fileBytes));
		while(true){					
			String line = reader.readLine();
			if(line == null)
				break;
			StringTokenizer tokenizer = (new StringTokenizer(line));
			if(!tokenizer.hasMoreTokens())
				continue;
			double x = Double.parseDouble(tokenizer.nextToken());
			double y = Double.parseDouble(tokenizer.nextToken());
			((Vertex)vertices.get(index)).textureCoords = new Vector2d(x, y);
			index++;
		}		
	}
	
	void loadConnectivity(String file){
		try{
			int fileLength = (int)(new File(file)).length();
			byte fileBytes[] = new byte[fileLength];
			FileInputStream fStream = new FileInputStream(file);
			fStream.read(fileBytes);
			fStream.close();
			
			System.out.println("Read file, processing..");
			ByteArrayInputStream bStream = new ByteArrayInputStream(fileBytes);

			DataInputStream dstream = new DataInputStream(bStream);
			while(dstream.available() > 0){
				int v1 = dstream.readInt();
				int v2 = dstream.readInt();
				int v3 = dstream.readInt();
				faces.add(new Face(v1, v2, v3, vertices, null));
			}			
			dstream.close();
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	/*
	void loadConnectivity(Mesh mesh){
		for(int i = 0; i < mesh.faces.size(); i++){
			Face f = (Face)mesh.faces.get(i);
			faces.add(new Face(f.vertices[0], f.vertices[1], f.vertices[2], 
					vertices, null));
		}
	}
	*/
	
		
	void loadFromVector(String file){
		try{
			int fileLength = (int)(new File(file)).length();
			byte fileBytes[] = new byte[fileLength];
			FileInputStream fStream = new FileInputStream(file);
			fStream.read(fileBytes);
			fStream.close();
			
			System.out.println("Read file " + file + ", processing..");
			ByteArrayInputStream bStream = new ByteArrayInputStream(fileBytes);

			DataInputStream dstream = new DataInputStream(bStream);
			while(dstream.available() > 0){
				float x = dstream.readFloat();
				float y = dstream.readFloat();
				float z = dstream.readFloat();
				vertices.add(new Vertex(this, x, y, z));
			}			
			dstream.close();
			loadConnectivity(BatchUtil.connectivityFile);
			System.out.println("Loaded from vector; " + vertices.size() + " verts, " 
					+ faces.size() + " faces");
			
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}

	
	void saveAsVector(String file){
		try{
			FileOutputStream fstream = new FileOutputStream(file, false);
			BufferedOutputStream bstream = new BufferedOutputStream(fstream, vertices.size()*6*4 + faces.size() * 13);
			DataOutputStream dstream = new DataOutputStream(bstream);				
			for(int i = 0; i < vertices.size(); i++){
				Vertex v = (Vertex)vertices.get(i);
				dstream.writeFloat((float)v.pos.x);
				dstream.writeFloat((float)v.pos.y);
				dstream.writeFloat((float)v.pos.z);					
			}
			dstream.close();
			System.out.println("Vector file saved: " + file);
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}

	void saveConnectivity(String file){
		try{
			FileOutputStream fstream = new FileOutputStream(file, false);
			BufferedOutputStream bstream = new BufferedOutputStream(fstream, vertices.size()*6*4 + faces.size() * 13);
			DataOutputStream dstream = new DataOutputStream(bstream);				
			for(int i = 0; i < faces.size(); i++){
				Face f = (Face)faces.get(i);
				dstream.writeInt(f.vertices[0]);
				dstream.writeInt(f.vertices[1]);
				dstream.writeInt(f.vertices[2]);
			}
			dstream.close();
			System.out.println("Connectivity saved to: " + file);
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}

	
	public void loadPly(String file){
		try{
			System.out.println("Reading input mesh: " + file);
			int fileLength = (int)(new File(file)).length();
			byte fileBytes[] = new byte[fileLength];
			FileInputStream fStream = new FileInputStream(file);
			fStream.read(fileBytes);
			fStream.close();
			
			System.out.println("Read file, processing..");
			ByteArrayInputStream bStream = new ByteArrayInputStream(fileBytes);
			
			//CharArrayReader cReader = new CharArrayReader(fileBytes);
			BufferedReader reader = new BufferedReader(new InputStreamReader(bStream));
			int headerLength = 0;
			
			headerLength += reader.readLine().length() + 1;
			String line = reader.readLine();
			headerLength += line.length() + 1;
			boolean binary = false, little_endian = false;
			if(line.indexOf("binary_little_endian") != -1){
				binary = true;
				little_endian = true;
			}
			else if(line.indexOf("binary_big_endian") != -1){
				binary = true;
				little_endian = false;
			}
			while(line.indexOf("vertex") == -1){
				line = reader.readLine();
				headerLength += line.length() + 1;
			}
			int numVertices = Integer.parseInt(line.substring(line.lastIndexOf(" ") + 1));
			while(line.indexOf("face") == -1){
				line = reader.readLine();
				headerLength += line.length() + 1;
			}
			int numFaces = Integer.parseInt(line.substring(line.lastIndexOf(" ") + 1));
			while(line.indexOf("end_header") == -1){
				line = reader.readLine();
				headerLength += line.length() + 1;
			}
			System.out.println("Finished reading ply header, " + numVertices + " vertices and " + numFaces + " faces");
			System.out.println("Header length: " + headerLength + " bytes");
			if(binary){
				reader.close();
				bStream = new ByteArrayInputStream(fileBytes);
				bStream.skip(headerLength);
				
				System.out.println("Reading binary data, little_endian: " + little_endian);				
				byte[] positions = new byte[numVertices * 3 * 4];
				
				System.out.println("Reading vertices");
				bStream.read(positions);
				
				byte a, b, c, d;
				float[] pos = new float[3];  
				int counter = 0;
				for(int i = 0; i < numVertices; i++){
					for(int j = 0; j < 3; j++){						
						if(little_endian){
							d = positions[counter];
							c = positions[counter + 1];
							b = positions[counter + 2];
							a = positions[counter + 3];
						}
						else{							
							a = positions[counter];
							b = positions[counter + 1];
							c = positions[counter + 2];
							d = positions[counter + 3];							
						}
						
						int intRep = (((a & 0xff) << 24) | ((b & 0xff) << 16) |
						 		  ((c & 0xff) << 8) | (d & 0xff));
						pos[j] = Float.intBitsToFloat(intRep);
						counter += 4;
					}					
					vertices.add(new Vertex(this, pos[0], pos[1], pos[2]));
					/*
					if(i > numVertices - 3)
						System.out.println(pos[0] + ", " + pos[1] + ", " + pos[2]);
					*/
				}

				int[] face = new int[3];
				byte faceBytes[] = new byte[numFaces * 13];
				
				counter = 0;
				System.out.println("Reading faces");
				bStream.read(faceBytes);
				
				for(int i = 0; i < numFaces ; i++){
					//int nVerts = bStream.read();
					counter++;
					if(i % 100000 == 0)
						System.out.println(i);
					for(int j = 0; j < 3; j++){
						if(little_endian){
							d = faceBytes[counter];
							c = faceBytes[counter + 1];
							b = faceBytes[counter + 2];
							a = faceBytes[counter + 3];
						}
						else{
							a = faceBytes[counter];
							b = faceBytes[counter + 1];
							c = faceBytes[counter + 2];
							d = faceBytes[counter + 3];						
						}
						//System.out.println("  " + Integer.toHexString(c) + "->" + c);
						//System.out.println("  " + (d & 0xff) + " " + (c & 0xff) + " " + (b & 0xff) + " " + (a & 0xff));
						int intRep = (((a & 0xff) << 24) | ((b & 0xff) << 16) |
						 		  ((c & 0xff) << 8) | (d & 0xff));
						//System.out.println("  " + intRep);
						
						face[j] = intRep;
						counter += 4;
					}
					
					if(face[0] >= numVertices || face[1] >= numVertices || face[2] >= numVertices){
						System.out.println("Beyond vertex range!");
					}
					else
						faces.add(new Face(face[0], face[1], face[2], vertices, edgeQueue));
					
				}
				
			}
			else{
				System.out.println("Text ply not yet supported");
			}
		}
		catch(FileNotFoundException e){
			System.out.println(e);			
		}
		catch(IOException e){
			System.out.println(e);						
		}
	}
	
	public void load(String file){	
		try{			
			//load obj file:
			if(getExtension(file).equals("obj")){
				loadOBJ(file);
			}
			else{
				String posFile = file + "pos.txt";
				loadPositions(posFile);
				String uvFile = file + "uv.txt";
				loadUV(uvFile);
			}
			System.out.println("Loaded " + vertices.size() + " vertices");
			System.out.println("Loaded " + faces.size() + " faces");
			//System.out.println("Loaded texture coordinates for " + textureCounter + " vertices");
			//loadTextures();						
		}
		catch(FileNotFoundException e){
			System.out.println(e);			
		}
		catch(IOException e){
			System.out.println(e);						
		}
		
	}	
	
	/*
	 * This will save the generated (obj) normals if saveNormals is true
	 */
	public void saveObj(String fileName, boolean saveNormals) {
		try{
			System.out.println("Saving as " + fileName);
			System.out.println("  writing to array");
			CharArrayWriter cWriter = new CharArrayWriter();
			//cWriter.write("# created by Aleksey Golovinskiy\n");
			cWriter.write("g Object__0\n");
			System.out.println("  writing vertices");
			for(int i = 0; i < vertices.size(); i++){
				Vertex v = (Vertex)vertices.get(i);
				cWriter.write("v " + v.pos.x + " " + v.pos.y + " " + v.pos.z + "\n");
			}
			if(saveNormals){
				System.out.println("  writing normals");
				for(int i = 0; i < vertices.size(); i++){
					Vertex v = (Vertex)vertices.get(i);
					cWriter.write("vn " + v.objNormal.x + " " + v.objNormal.y + " " + v.objNormal.z + "\n");
				}				
			}
			System.out.println("  writing faces");
			for(int i = 0 ; i < faces.size(); i++){
				Face f = (Face)faces.get(i);
				cWriter.write("f " + (f.vertices[0] + 1) + " " + (f.vertices[1] + 1) + " " + (f.vertices[2] + 1) + "\n");
			}
			char chars[] = cWriter.toCharArray();
			
			FileWriter writer = new FileWriter(fileName);
			System.out.println("  writing to file");
			writer.write(chars);
			writer.close();
			System.out.println("  saved");
		}
		catch(IOException e){
			System.out.println(e);
		}
	}
	
	public void coarsen(){
		LinkedList coarseVertexQueue = new LinkedList();
		Set fineVertexList = new HashSet();
		Vertex firstVertex = (Vertex)vertices.get(0);
		coarseVertexQueue.add(firstVertex);
		fineVertexList.addAll(firstVertex.neighbors);
		for(int k = 0; k < 10000; k++){
			if(coarseVertexQueue.isEmpty()){
				System.out.println("Reached end of coarse queue");
				break;
			}
			Vertex v = (Vertex)coarseVertexQueue.get(0);
			coarseVertexQueue.removeFirst();
			v.bright = true;
			List neighbors = v.neighbors;
			for(int i = 0; i < neighbors.size(); i++){
				Vertex neighbor = (Vertex)neighbors.get(i);
//				fineVertexList.add(neighbor);
//				System.out.println("Adding to fine list: " + neighbor.index);
				if(neighbor.bright){
					System.out.println("Error: brightened vertex contains bright neighbor");
					return;
				}
				else{
					List secondNeighbors = neighbor.neighbors;
					for(int j = 0; j < secondNeighbors.size(); j++){
						Vertex secondNeighbor = (Vertex)secondNeighbors.get(j);
						if(!secondNeighbor.bright && !coarseVertexQueue.contains(secondNeighbor) 
								&& !fineVertexList.contains(secondNeighbor)){
							secondNeighbor.bright = true;
							coarseVertexQueue.add(secondNeighbor);
							fineVertexList.addAll(secondNeighbor.neighbors);
							//System.out.println("Adding to coarse list: " + secondNeighbor.index);
						}
					}					
				}
			}
		}
	}
	
	public void smooth(){
		for(int i = 0; i < vertices.size(); i++){
			Vertex v = (Vertex)vertices.get(i);
			List neighbors = (List)vertex2neighbors.get(i);
			v.newPos = new Vector3d();			
			for(int j = 0; j < neighbors.size(); j++)
				v.newPos.add(((Vertex)neighbors.get(j)).pos);
			v.newPos.scale(1.0 / neighbors.size());
			//v.newPos.interpolate(v.pos, .5);			
		}
		for(int i = 0; i < vertices.size(); i++){
			Vertex v = (Vertex)vertices.get(i);
			Vector3d diff = new Vector3d();
			diff.sub(v.pos, v.newPos);
			//System.out.println(diff);
			v.pos.set(v.newPos);
		}
	}
	
	static Mesh rectangle(int n){
		Mesh mesh = new Mesh();
		mesh.meshFile = "rect.ply";
		int jSize = n;
		int iSize = (int)(n * 2/Math.sqrt(3));
		Vertex[][] vertexArray = new Vertex[iSize][jSize];
		double step = 1.0/jSize;
		for(int i = 0 ; i < iSize; i++){
			for(int j = 0; j < jSize; j++){
				vertexArray[i][j] = new Vertex(mesh, (j + (i%2) / 2.0) * step, i * step * Math.sqrt(3)/2, 0);
				vertexArray[i][j].index = mesh.vertices.size();
				mesh.vertices.add(vertexArray[i][j]);
			}
		}
		for(int i = 0; i < iSize - 1; i++){
			for(int j = 0; j < jSize - 1; j++){
				Vertex v0 = vertexArray[i][j];
				Vertex v1 = vertexArray[i][j + 1];
				Vertex v2 = vertexArray[i + 1][j + 1];
				Vertex v3 = vertexArray[i + 1][j];
				if(i%2 == 0){
					mesh.faces.add(new Face(v0.index, v1.index, v3.index, mesh.vertices, null));
					mesh.faces.add(new Face(v1.index, v2.index, v3.index, mesh.vertices, null));
				}
				else{
					mesh.faces.add(new Face(v0.index, v2.index, v3.index, mesh.vertices, null));
					mesh.faces.add(new Face(v0.index, v1.index, v2.index, mesh.vertices, null));
				}
			}
		}
		mesh.createAdjacency();
		mesh.computeNormals();
		return mesh;
	}
	
	static Mesh rectangle(int n, double x, double y, double maxZ, double scale){
		Mesh rect = rectangle(n);
		for(int i = 0; i < rect.vertices.size(); i++){
			Vertex v = (Vertex)rect.vertices.get(i);
			v.pos.add(new Vector3d(-.5, -.5, 0));
			v.pos.scale(scale);
			v.pos.add(new Vector3d(x, y, maxZ + .01));
		}		
		rect.setFaceProperties();
		rect.meshFile = "rect.ply";
		return rect;
	}
	
	void loadMarkers(String file){
		try{
			BufferedReader reader = new BufferedReader(new FileReader(file));
			String line = reader.readLine();
			line = reader.readLine();
			markers = new ArrayList();
			while(line != null){
				String vertexNumStr = line.split(" ")[3];
				int vertexNum = Integer.parseInt(vertexNumStr);
				System.out.println("  adding vertex " + vertexNum);
				markers.add(vertices.get(vertexNum));
				line = reader.readLine();
			}
			reader.close();
		}
		catch(IOException e){
			System.out.println(e);
		}
	}
		
	double[] projectOn(Mesh target){
		Vector3d diff = new Vector3d();
		int foundCounter = 0;
		//Vector3d max = new Vector3d(Double.NEGATIVE_INFINITY, Double.NEGATIVE_INFINITY, Double.NEGATIVE_INFINITY);
		//Vector3d min = new Vector3d(Double.POSITIVE_INFINITY, Double.POSITIVE_INFINITY, Double.POSITIVE_INFINITY);
		if(target.grid == null)
			target.grid = new Grid(target, 160, 160, 40);
		Grid grid = target.grid;
		double[] details = new double[vertices.size()];
		Vector3d hitPos = new Vector3d();
		for(int i = 0; i < vertices.size(); i++){
			if(i % 5000 == 0)
				System.out.println("  ref vertex: " + i + " / " + vertices.size());
			Vertex refVertex = (Vertex)vertices.get(i);
			Vector3d projDir = new Vector3d(refVertex.objNormal);
			
			Grid.Hit h1 = grid.new Hit();				
			boolean hit1 = grid.traceRay(grid.new Ray(projDir, refVertex.pos), h1, 0, false);
			projDir.negate();
			/*
			if(refVertex.index == 330){
				System.out.println("marked vertex: ");
			}
			*/
			Grid.Hit h2 = grid.new Hit();
			boolean hit2 = grid.traceRay(grid.new Ray(projDir, refVertex.pos), h2, 0, false);
			double t = Double.POSITIVE_INFINITY;
			if(hit1 || hit2){				
				foundCounter++;
				if(hit1 && hit2){
					if(h1.t < h2.t){
						hitPos.set(h1.intersectionPoint);
						t = h1.t;
					}
					else{
						hitPos.set(h2.intersectionPoint);
						t = -h2.t;
					}
				}
				else if(hit1){
					hitPos.set(h1.intersectionPoint);
					t = h1.t;
				}
				else if(hit2){
					hitPos.set(h2.intersectionPoint);
					t = -h2.t;
				}
				else
					throw new RuntimeException("Impossible case");
				
				details[i] = t;
				refVertex.pos.set(hitPos);
			}
			else
				refVertex.markedForDeletion = true;
			/*
			//check that grid intersection has same result as normal slow intersection:
			Vector3d intersection = Correspondence.project(refVertex.pos, projDir, target);
			if(intersection != null){
				if(refVertex.markedForDeletion){
					System.out.println("Error; intersection not found but should have been found");
				}
				else{
					diff.sub(intersection, refVertex.pos);
					if(diff.length() > .00000000001)
						System.out.println(diff.length());
				}				
			}
			else{
				if(!refVertex.markedForDeletion){
					System.out.println("Error; intersection found, but should not have been");
				}
			}
			*/
			
		}
		System.out.println("  found intersections for " + foundCounter + " / " + vertices.size() + " vertices, removing extra verts");
		if(foundCounter != vertices.size() )
			throw new RuntimeException();
		deleteMarkedVertices();
		setFaceProperties();
		computeNormals();
		createAdjacency();
		System.out.println("  done");	
		return details;		
	}
	
	void convegeMarkers(List targetMarkers){
		if(targetMarkers.size() != markers.size())
			throw new RuntimeException("Number of target markers not same as reference markers");
		Vector3d diff = new Vector3d();
		for(int i = 0; i < markers.size(); i++){
			Vertex refMarker = (Vertex)markers.get(i);			
			Vertex targetMarker = (Vertex)targetMarkers.get(i);
			diff.sub(targetMarker.pos, refMarker.pos);
			if(diff.length() < .0001)
				continue;
			
			double shortestEdge = Double.POSITIVE_INFINITY;
			
			List neighbors = (List)vertex2neighbors.get(refMarker.index);
			for(int j = 0; j < neighbors.size(); j++){
				Vertex neighbor = (Vertex)neighbors.get(j);
				diff.sub(neighbor.pos, refMarker.pos);
				double length = diff.length();
				if(length < shortestEdge)
					shortestEdge = length;
			}
			diff.sub(targetMarker.pos, refMarker.pos);
			double dist = shortestEdge * .25;
			if(dist > diff.length())
				dist = diff.length();
			diff.normalize();
			refMarker.pos.scaleAdd(dist, diff, refMarker.pos);
		}
		
	}
	
	void relax(){		
		/*
		Vector3d diff = new Vector3d();
		
		setFaceProperties();
		

		double sum = 0;
		for(int i = 0; i < faces.size(); i++){
			Face f = (Face)faces.get(i);
			for(int j = 0; j < 3; j++){
				//System.out.println(f.edgeLengths[j]);
				sum += f.edgeLengths[j]; //not adjusted!
			}
		}
		double avgLength = sum / faces.size() / 3;
		System.out.println("Average edge length: " + avgLength);
		
		int numIterations = 1;
		for(int k = 0; k < numIterations; k++){
			for(int i = 0; i < vertices.size(); i++){
				Vertex v = (Vertex)vertices.get(i);
				//v.newPos = new Vector3d(v.pos);
				v.newPos = new Vector3d();
				if(!markers.contains(v)){
					List neighbors = (List)vertex2neighbors.get(i);
					for(int j = 0; j < neighbors.size(); j++){
						Vertex neighbor = (Vertex)neighbors.get(j);
						diff.sub(neighbor.pos, v.pos);
						//System.out.println(diff.length());
						//if(diff.length() > avgLength)
							
						//v.newPos.scaleAdd((diff.length() - avgLength) * .01, diff, v.newPos);
						v.newPos.add(neighbor.pos);
					}				
					v.newPos.scale(1.0 / neighbors.size());
				}
			}
			
			for(int i = 0; i < vertices.size(); i++){
				Vertex v = (Vertex)vertices.get(i);
				List neighbors = (List)vertex2neighbors.get(i);				
				//if(!markers.contains(v) && (neighbors.size() == 6)){
					//v.pos.set(v.newPos);
				v.pos.interpolate(v.pos, v.newPos, .5);
				//}
			}
		}
		setFaceProperties();
		computeNormals();
		*/
	}


	void setFaceProperties(){
		for(int i = 0; i < faces.size(); i++){
			Face f = (Face)faces.get(i);
			f.setProperties(vertices, null);
		}
	}
	
	void addBaseMeshConnectivity(){
		if(vertices.size() != numBaseVertices)
			throw new RuntimeException();
		
		faces.add(new Face(2, 1, 0, vertices, null));
		faces.add(new Face(1, 3, 0, vertices, null));
		faces.add(new Face(2, 3, 1, vertices, null));
		faces.add(new Face(4, 8, 2, vertices, null));
		faces.add(new Face(8, 3, 2, vertices, null));
		faces.add(new Face(8, 5, 3, vertices, null));
		//result.faces.add(new Face(4, 2, 6, result.vertices, null));
		//result.faces.add(new Face(2, 0, 6, result.vertices, null));
		//result.faces.add(new Face(5, 7, 3, result.vertices, null));
		//result.faces.add(new Face(3, 7, 0, result.vertices, null));
		
		faces.add(new Face(6, 10, 9, vertices, null));
		faces.add(new Face(0, 10, 6, vertices, null));
		faces.add(new Face(7, 10, 0, vertices, null));
		faces.add(new Face(7, 11, 10, vertices, null));
		faces.add(new Face(12, 13, 4, vertices, null));
		faces.add(new Face(13, 8, 4, vertices, null));
		faces.add(new Face(13, 5, 8, vertices, null));
		faces.add(new Face(13, 14, 5, vertices, null));
		faces.add(new Face(15, 6, 9, vertices, null));
		//result.faces.add(new Face(15, 4, 6, result.vertices, null));
		//result.faces.add(new Face(16, 4, 15, result.vertices, null));
		faces.add(new Face(12, 4, 16, vertices, null));
		faces.add(new Face(14, 18, 5, vertices, null));
		//result.faces.add(new Face(5, 18, 17, result.vertices, null));
		//result.faces.add(new Face(5, 17, 7, result.vertices, null));
		faces.add(new Face(7, 17, 11, vertices, null));
		
		faces.add(new Face(16, 19, 15, vertices, null));
		faces.add(new Face(15, 19, 6, vertices, null));
		faces.add(new Face(6, 19, 0, vertices, null));
		faces.add(new Face(0, 19, 2, vertices, null));
		faces.add(new Face(2, 19, 4, vertices, null));
		faces.add(new Face(4, 19, 16, vertices, null));

		faces.add(new Face(18, 17, 20, vertices, null));
		faces.add(new Face(17, 7, 20, vertices, null));
		faces.add(new Face(7, 0, 20, vertices, null));
		faces.add(new Face(20, 0, 3, vertices, null));
		faces.add(new Face(20, 3, 5, vertices, null));
		faces.add(new Face(20, 5, 18, vertices, null));
		
		
		createAdjacency();

	}
	
	Mesh baseMesh(){
		Mesh result = new Mesh();
		result.meshFile = "base_" + meshFile;
		//result.vertices.addAll(markers);
		for(int i = 0; i < markers.size(); i++){
			Vertex marker = (Vertex)markers.get(i);
			result.vertices.add(new Vertex(marker, result));
		}
		
		/*
		result.faces.add(new Face(2, 1, 0, result.vertices, null));
		result.faces.add(new Face(1, 3, 0, result.vertices, null));
		result.faces.add(new Face(2, 3, 1, result.vertices, null));
		result.faces.add(new Face(4, 8, 2, result.vertices, null));
		result.faces.add(new Face(8, 3, 2, result.vertices, null));
		result.faces.add(new Face(8, 5, 3, result.vertices, null));
		//result.faces.add(new Face(4, 2, 6, result.vertices, null));
		//result.faces.add(new Face(2, 0, 6, result.vertices, null));
		//result.faces.add(new Face(5, 7, 3, result.vertices, null));
		//result.faces.add(new Face(3, 7, 0, result.vertices, null));
		
		result.faces.add(new Face(6, 10, 9, result.vertices, null));
		result.faces.add(new Face(0, 10, 6, result.vertices, null));
		result.faces.add(new Face(7, 10, 0, result.vertices, null));
		result.faces.add(new Face(7, 11, 10, result.vertices, null));
		result.faces.add(new Face(12, 13, 4, result.vertices, null));
		result.faces.add(new Face(13, 8, 4, result.vertices, null));
		result.faces.add(new Face(13, 5, 8, result.vertices, null));
		result.faces.add(new Face(13, 14, 5, result.vertices, null));
		result.faces.add(new Face(15, 6, 9, result.vertices, null));
		//result.faces.add(new Face(15, 4, 6, result.vertices, null));
		//result.faces.add(new Face(16, 4, 15, result.vertices, null));
		result.faces.add(new Face(12, 4, 16, result.vertices, null));
		result.faces.add(new Face(14, 18, 5, result.vertices, null));
		//result.faces.add(new Face(5, 18, 17, result.vertices, null));
		//result.faces.add(new Face(5, 17, 7, result.vertices, null));
		result.faces.add(new Face(7, 17, 11, result.vertices, null));
		
		result.faces.add(new Face(16, 19, 15, result.vertices, null));
		result.faces.add(new Face(15, 19, 6, result.vertices, null));
		result.faces.add(new Face(6, 19, 0, result.vertices, null));
		result.faces.add(new Face(0, 19, 2, result.vertices, null));
		result.faces.add(new Face(2, 19, 4, result.vertices, null));
		result.faces.add(new Face(4, 19, 16, result.vertices, null));

		result.faces.add(new Face(18, 17, 20, result.vertices, null));
		result.faces.add(new Face(17, 7, 20, result.vertices, null));
		result.faces.add(new Face(7, 0, 20, result.vertices, null));
		result.faces.add(new Face(20, 0, 3, result.vertices, null));
		result.faces.add(new Face(20, 3, 5, result.vertices, null));
		result.faces.add(new Face(20, 5, 18, result.vertices, null));
		
		
		result.createAdjacency();
		*/
		result.addBaseMeshConnectivity();
		result.setFaceProperties();
		result.computeNormals();
		result.setBaseBoundary();
		//result.addPlaneCoords(1);
		return result;
	}
	
	static void eraseDetails(){
		details = new double[0][][]; 
	}
	static void readDetails(String detailFile){
		try{
			int fileLength = (int)(new File(detailFile)).length();
			byte fileBytes[] = new byte[fileLength];
			FileInputStream fStream = new FileInputStream(detailFile);
			fStream.read(fileBytes);
			fStream.close();
			DataInputStream dstream = new DataInputStream(new ByteArrayInputStream(fileBytes));
			dstream.skipBytes(fileLength - 4);
			int numLevels = dstream.readInt() + 1;
			System.out.println("  number of detail levels: " + numLevels + ", labeled as source: " + details.length + "; from: " + detailFile);			
			dstream = new DataInputStream(new ByteArrayInputStream(fileBytes));
			//dstream.reset();
			double[][] detailsSet = new double[numLevels][];
			for(int i = 0; i < detailsSet.length; i++){
				int numVerts = dstream.readInt();
				detailsSet[i] = new double[numVerts];
				for(int j = 0; j < numVerts; j++){
					detailsSet[i][j] = dstream.readDouble();
				}
				int levelRead = dstream.readInt();
				System.out.println("    finished reading level " + levelRead + ", vertices: " + numVerts);
			}
			
			double[][][] oldDetails = details;
			details = new double[details.length + 1][][];
			for(int i = 0; i < details.length - 1; i++)
				details[i] = oldDetails[i];			
			details[details.length - 1] = detailsSet;
		}
		catch(IOException e){
			e.printStackTrace();
		}
	}
	
	void applyDetail(double detail[]){
		//subdivide();
		if(vertices.size() != detail.length)
			throw new RuntimeException(detail.length + " detail coefficients but " + vertices.size() + " vertices");
		
		for(int i = 0; i < vertices.size(); i++){
			Vertex v = (Vertex)vertices.get(i);
			v.pos.scaleAdd(detail[i], v.objNormal, v.pos);
		}
		setFaceProperties();
		computeNormals();
	}
	
	Mesh applyDetail(int detailSource){
		System.out.println("Applying detail from source: " + detailSource + " at level: " + detailLevel);
		Mesh result = this; //*/new Mesh(this);
		double properDetails[] = null;
		
		for(int i = 0; i < details[detailSource].length; i++){
			if(details[detailSource][i].length == vertices.size()){
				properDetails = details[detailSource][i];
				break;
			}
		}
		if(properDetails == null){
			System.out.println("Unable to find a proper level of detail");
			return null;
		}
		result.applyDetail(properDetails);
		result.meshFile = meshFile;
		//result.meshFile = detailSource + " " + meshFile; 
		result.detailLevel++;
		return result;
	}
	
	public static Vertex closestVertexToLine(List vertices, Vector3d startPoint, Vector3d endPoint){
    	Vector3d dir = new Vector3d();
    	dir.sub(startPoint, endPoint);
    	dir.normalize();
		Vector3d diff = new Vector3d();
    	double minDist = Double.POSITIVE_INFINITY;
		Vertex closestVertex = null;
    	for(int j = 0; j < vertices.size(); j++){
    		Vertex v = (Vertex)vertices.get(j);
    		diff.sub(endPoint, v.pos);
    		diff.cross(diff, dir);
    		double distSquared = diff.lengthSquared();
    		if(distSquared < minDist){
    			minDist = distSquared;
    			closestVertex = v;
    		}
    	}
    	System.out.println("   Closest vertex: " + closestVertex.index + ", " + closestVertex.pos);
    	return closestVertex;
	}
	
	void projectToClosestVertex(Mesh target){
		for(int i = 0; i < vertices.size(); i++){
			Vertex v = (Vertex)vertices.get(i);
			Vector3d startPos = new Vector3d(v.pos);
			Vector3d endPos = new Vector3d(startPos);
			endPos.add(v.objNormal);
			Vertex closestVertex = closestVertexToLine(target.vertices, startPos, endPos);
			v.pos.set(closestVertex.pos);			
		}
		computeNormals();
	}
	
	static private Mesh referenceBaseMesh;
	
	static Mesh getReferenceBaseMesh(){
		if(referenceBaseMesh == null)
			referenceBaseMesh = new Mesh("Data\\Reference\\base_mesh.ply");
		return referenceBaseMesh;
	}
	
	void augmentMarkersWithBase(){
		augmentMarkersWithBase(getReferenceBaseMesh());
	}
	
	
	void augmentMarkersWithBase(Mesh base){
		base.projectToClosestVertex(this);
		
		if(markers == null)
			markers = new ArrayList();
		for(int i = markers.size(); i < base.vertices.size(); i++){
			markers.add(new Vertex((Vertex)base.vertices.get(i), this));
		}
		
	}
	
	int closestVertexTo(Vertex v){
		double closestDist = Double.POSITIVE_INFINITY;
		Vertex closestVert = null;
		Vector3d diff = new Vector3d();
		for(int i = 0; i < vertices.size(); i++){
			Vertex vert = (Vertex)vertices.get(i);
			diff.sub(v.pos, vert.pos);
			double dist = diff.lengthSquared();
			if(dist < closestDist){
				closestDist = dist;
				closestVert = vert;
			}
		}
		return vertices.indexOf(closestVert);
	}
	
	
	/*
	double getImageOffset(Image image, Vector3d pos3d){
		Vector2f pos = new Vector2f((float)pos3d.x, (float)pos3d.y);
		pos.x = (pos.x + 1) / 2 * (image.width - 1);
		pos.y = (pos.y + 1) / 2 * (image.height - 1);
	
		return image.data[Math.round(pos.x)][Math.round(pos.y)];
	}
	*/
	
	void applyImageDetail(String file){
		applyImageDetail(new Image(file));
	}
	void applyImageDetail(Image image){
		/*
		Mesh myImageMesh = imageMesh;
		if(myImageMesh == null)
			myImageMesh = globalImageMesh;
		*/ 
		double maxOffset = Double.NEGATIVE_INFINITY;
		double maxError = 0;
		Vector3d maxErrorPos = null;
		for(int i = 0; i < vertices.size(); i++){
			Vertex v = (Vertex)vertices.get(i);
			//Vertex imageVertex = (Vertex)myImageMesh.vertices.get(i);
			Vertex imageVertex = (Vertex)getFinalImageMesh().vertices.get(i);
			//System.out.println(imageVertex.pos);
			double offset = image.data((float)imageVertex.pos.x, (float)imageVertex.pos.y);//getImageOffset(image, imageVertex.pos);			
			double error = Double.NaN;
			/*
			if(details != null && details.length > 0 && details[0] != null && details[0].length > detailLevel)
				error = Math.abs(offset - details[0][detailLevel][i]);
			*/
			//if(offset > maxOffset) maxOffset = offset;
			if(error > maxError){
				maxError = error;
				maxOffset = offset;
				maxErrorPos = imageVertex.pos;
			}
			//System.out.println(error);
			//details[0][detailLevel][i] = error;
			//System.out.println(offset + "; " + details[0][detailLevel][i]);
			v.pos.scaleAdd(offset, v.objNormal, v.pos);
		}		
		System.out.println("Max error: " + maxError + ", max error offset: " + maxOffset + ", pos: " + maxErrorPos);
		
		setFaceProperties();
		computeNormals();
}
	
	/*
	private void flipPlaneCoords(int from, int to){
		Vertex v1 = (Vertex)vertices.get(from);
		Vertex v2 = (Vertex)vertices.get(to);
		v2.textureCoords = new Vector2d();
		v2.textureCoords.x = -v1.textureCoords.x;
		v2.textureCoords.y = v1.textureCoords.y;
	}
	*/
	private void flipCoords(int from, int to){
		Vertex v1 = (Vertex)vertices.get(from);
		Vertex v2 = (Vertex)vertices.get(to);
		v2.pos = new Vector3d();
		v2.pos.x = -v1.pos.x;
		v2.pos.y = v1.pos.y;
	}

	
	void makeImageMesh(){
		for(int i = 0; i < numBaseVertices; i++)
			vertices.add(new Vertex(this, 0, 0, 0));
		
		setBaseBoundary();
		
		float size = 1;
		
		((Vertex)vertices.get(10)).pos = new Vector3d(0, size, 0);
		((Vertex)vertices.get(0)).pos = new Vector3d(0, size / 2, 0);
		((Vertex)vertices.get(1)).pos = new Vector3d(0, 0, 0);
		((Vertex)vertices.get(8)).pos = new Vector3d(0, -size / 2, 0);
		((Vertex)vertices.get(13)).pos = new Vector3d(0, -size, 0);
		
		((Vertex)vertices.get(9)).pos = new Vector3d(-size, size, 0);
		((Vertex)vertices.get(6)).pos = new Vector3d(-size * 3/4, size / 2, 0);
		((Vertex)vertices.get(15)).pos = new Vector3d(-size, size / 4, 0);
		((Vertex)vertices.get(16)).pos = new Vector3d(-size, -size / 2, 0);
		((Vertex)vertices.get(12)).pos = new Vector3d(-size, -size, 0);
		((Vertex)vertices.get(2)).pos = new Vector3d(-size / 4, -size / 4, 0);
		((Vertex)vertices.get(4)).pos = new Vector3d(-size / 2, -size / 2, 0);

		((Vertex)vertices.get(19)).pos = new Vector3d(-size / 2, size / 5, 0);
		
		flipCoords(9, 11);
		flipCoords(6, 7);
		flipCoords(15, 17);
		flipCoords(2, 3);
		flipCoords(16, 18);
		flipCoords(4, 5);
		flipCoords(12, 14);
		flipCoords(19, 20);		
		
		int width = Loader.imageSize, height = Loader.imageSize;
		
		for(int i = 0; i < vertices.size(); i++){
			Vertex v = (Vertex)vertices.get(i);
			v.baseVertex = true;			
			v.pos.set((v.pos.x + 1) / 2 * (width - 1), (v.pos.y + 1) / 2 * (height - 1), 0);
		}
		
		addBaseMeshConnectivity();
	}

	
	public void setBoundary(int v){
		((Vertex)vertices.get(v)).boundary = true;
	}
	
	/*
	public void createImageMesh(){
		setBaseBoundary();
		addPlaneCoords(1);
	}
	*/
	
	public void setBaseBoundary(){
		setBoundary(9);
		setBoundary(15);
		setBoundary(16);
		setBoundary(12);
		setBoundary(13);
		setBoundary(14);
		setBoundary(18);
		setBoundary(17);
		setBoundary(11);
		setBoundary(10);
	}
	
	/*
	public void addPlaneCoords(float size){
		if(vertices.size() != numBaseVertices)
			throw new RuntimeException("incorrect number of vertices");
		
		((Vertex)vertices.get(10)).textureCoords = new Vector2d(0, size);
		((Vertex)vertices.get(0)).textureCoords = new Vector2d(0, size / 2);
		((Vertex)vertices.get(1)).textureCoords = new Vector2d(0, 0);
		((Vertex)vertices.get(8)).textureCoords = new Vector2d(0, -size / 2);
		((Vertex)vertices.get(13)).textureCoords = new Vector2d(0, -size);
		
		((Vertex)vertices.get(9)).textureCoords = new Vector2d(-size, size);
		((Vertex)vertices.get(6)).textureCoords = new Vector2d(-size * 3/4, size / 2);
		((Vertex)vertices.get(15)).textureCoords = new Vector2d(-size, size / 4);
		((Vertex)vertices.get(16)).textureCoords = new Vector2d(-size, -size / 2);
		((Vertex)vertices.get(12)).textureCoords = new Vector2d(-size, -size);
		((Vertex)vertices.get(2)).textureCoords = new Vector2d(-size / 4, -size / 4);
		((Vertex)vertices.get(4)).textureCoords = new Vector2d(-size / 2, -size / 2);

		((Vertex)vertices.get(19)).textureCoords = new Vector2d(-size / 2, size / 5);
		
		flipPlaneCoords(9, 11);
		flipPlaneCoords(6, 7);
		flipPlaneCoords(15, 17);
		flipPlaneCoords(2, 3);
		flipPlaneCoords(16, 18);
		flipPlaneCoords(4, 5);
		flipPlaneCoords(12, 14);
		flipPlaneCoords(19, 20);		
		
		imageMesh = new Mesh(this);
		int width = Loader.imageSize, height = Loader.imageSize;
		
		for(int i = 0; i < vertices.size(); i++){
			Vertex imageVertex = (Vertex)imageMesh.vertices.get(i);
			Vertex v = (Vertex)vertices.get(i);
			v.baseVertex = true;
			imageVertex.baseVertex= true;							
			
			imageVertex.pos.set((v.textureCoords.x + 1) / 2 * (width - 1), (v.textureCoords.y + 1) / 2 * (height - 1), 0);
			imageVertex.boundary = v.boundary;
			v.textureCoords = null;
		}
		
		
		
		imageMesh.setFaceProperties();
		imageMesh.computeNormals();
	}
	*/	
	
	
	//non-oriented edge
	private class EdgeInt{
		int v1, v2;
		
		public EdgeInt(int i, int j){
			v1 = i;
			v2 = j;
		}
		
		public boolean equals(Object o){
			if(!(o instanceof EdgeInt))
				return false;
			EdgeInt e = (EdgeInt)o;
			return (v1 == e.v1 && v2 == e.v2) || (v2 == e.v1 && v1 == e.v2);
		}
		
		public int hashCode(){
			//int hash = 0;
			//System.out.println(this + ": " + hash);
			return ((v1 + 1) * (v2 + 1));
		}
		
		public String toString(){
			return "{" + v1 + " " + v2 + "}";
		}
	}

	private class EdgeComparator implements Comparator{

		public int compare(Object arg0, Object arg1) {
			if(arg0.equals(arg1))
				return 0;
			Edge e1 = (Edge)arg0;
			Edge e2 = (Edge)arg1;
			if(e1.length < e2.length)
				return 1;
			else if(e1.length > e2.length)
				return -1;
			else{
				if(e1.v1 > e2.v1)
					return 1;
				else if (e1.v1 < e2.v1)
					return -1;
				else{
					if(e1.v2 > e2.v2)
						return 1;
					else
						return -1;
				}
			}
		}
		
		
	}
}