/*
 * Created on Jul 20, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jogl;

import java.util.ArrayList;
import java.util.List;

import javax.vecmath.Vector2d;
import javax.vecmath.Vector2f;
import javax.vecmath.Vector3d;

/**
 * @author golovins
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Raster {
	double data[][];
	int width;
	int height;
	
	int hits[][];
	List faces[][];
	
	public Raster(int width, int height){
		this.width = width;
		this.height = height;
		data = new double[width][];
		hits = new int[width][];
		faces = new List[width][];
		for(int i = 0; i < data.length; i++){
			data[i] = new double[height];
			hits[i] = new int[height];
			faces[i] = new List[height];
			for(int j = 0; j < height; j++){
				faces[i][j] = new ArrayList();
			}
		}
	}

	public Raster(int width, int height, /*Mesh m, */double details[]){
		this(width, height);
		rasterize(/*m, */details);
		
	}	
	
	int[] vertex2image(Vertex imageVertex){
		Vector3d pos3d = imageVertex.pos;
		Vector2d pos = new Vector2d(pos3d.x, pos3d.y);
		//pos.x = (pos.x + 1) / 2 * (width);
		//pos.y = (pos.y + 1) / 2 * (height);
		int x = Math.round((float)pos.x);
		int y = Math.round((float)pos.y);
		if(x == width) x = width - 1;
		if(y == height) y = height - 1;
		return new int[]{x, y};
	}
	
	void addFace(Face f){		
		Vector2f objMin = new Vector2f(Float.POSITIVE_INFINITY, Float.POSITIVE_INFINITY);
		Vector2f objMax = new Vector2f(Float.NEGATIVE_INFINITY, Float.NEGATIVE_INFINITY);
		for(int i = 0; i < 3; i++){
			Vertex v = f.verts[i];
			if(v.pos.x < objMin.x) objMin.x = (float)v.pos.x;
			if(v.pos.y < objMin.y) objMin.y = (float)v.pos.y;
			
			if(v.pos.x > objMax.x) objMax.x = (float)v.pos.x;
			if(v.pos.y > objMax.y) objMax.y = (float)v.pos.y;
		}
		
		int startIndex[] = new int[2],  endIndex[] = new int[2]; //grid indices in which corners of bounding box fall
		startIndex[0] = Math.round(objMin.x);
		startIndex[1] = Math.round(objMin.y);
		
		endIndex[0] = Math.round(objMax.x);
		endIndex[1] = Math.round(objMax.y);
		
		  
		for(int x = startIndex[0]; x <= endIndex[0]/* && x < width*/; x++)
			for(int y = startIndex[1]; y <= endIndex[1]/* && y < height*/; y++)
					faces[x][y].add(f);
				
	}
	
	
	public void rasterize(/*Mesh m, */double details[]){
		if(Mesh.getFinalImageMesh().vertices.size() != details.length)
			throw new RuntimeException("Details size does not match vertices");
		
		for(int i = 0; i < Mesh.getFinalImageMesh().vertices.size(); i++){
			//Vertex v = (Vertex)m.vertices.get(i);
			//Vertex imageVertex = (Vertex)m.imageMesh.vertices.get(i);
			Vertex imageVertex = (Vertex)Mesh.getFinalImageMesh().vertices.get(i);
			int[] coords = vertex2image(imageVertex);
			//data[coords[0]][coords[1]] = details[i];
			hits[coords[0]][coords[1]]++;
		}
		
		/*
		for(int i = 0; i < width; i++)
			for(int j = 0; j < height; j++)
				if(hits[i][j] == 0)
					data[i][j] = -1;
		*/
		printInfo();
		System.out.println("  adding faces to raster grid");
		
		//for(int i = 0; i < m.imageMesh.faces.size(); i++){
		for(int i = 0; i < Mesh.getFinalImageMesh().faces.size(); i++){
			if(i % 40000 == 0)
				System.out.println("    " + i);
			//addFace((Face)m.imageMesh.faces.get(i));
			addFace((Face)Mesh.getFinalImageMesh().faces.get(i));
		}
		
		double eps = Grid.eps;
		
		System.out.println("  projecting raster grid on mesh");
		for(int x = 0; x < width; x++){
			if(x%200 == 0)
				System.out.println("    " + x);
			for(int y = 0; y < height; y++){				
				//System.out.println(y);
				List triangles = this.faces[x][y]; //m.imageMesh.faces;
				boolean intersected = false;
				for(int i = 0; i < triangles.size(); i++){
					Face f = (Face)triangles.get(i);
					Vector3d intersection = Correspondence.triangleRayIntersect(f.verts[0].pos, f.verts[1].pos, f.verts[2].pos, 
							new Vector3d(x, y, 0), new Vector3d(0, 0, 1));
					if(intersection.y >= -eps && intersection.z >= -eps && intersection.y + intersection.z <= 1 + eps){
						intersected = true;

						data[x][y] = details[f.vertices[1]] * intersection.y + 
									 details[f.vertices[2]] * intersection.z + 
									 details[f.vertices[0]] * (1 - intersection.y - intersection.z); 
						/*
						if(x == 392 && y == 394){
							System.out.println("interesected triangle: " + f);
							System.out.println("baryocenteric coords: " + intersection.y + " " + intersection.z + " " + (1 - intersection.y - intersection.z));
							System.out.println("details: " + details[f.vertices[0]] + ", " + details[f.vertices[1]] + ", " + details[f.vertices[2]]);
							System.out.println("detail: " + data[x][y]);
						}
						*/
						break;
					}
				}
				if(!intersected)
					System.out.println("ERROR, NO INTERSECTION!");
			}
		}
	}
	
	public void printInfo(){
		int maxHits = 0;
		float sum = 0;
		int numZeroes = 0;
		for(int i = 0; i < width; i++){
			for(int j = 0; j < width; j++){
				sum += hits[i][j];
				if(hits[i][j] > maxHits)
					maxHits = hits[i][j];
				if(hits[i][j] == 0)
					numZeroes++;
			}
		}
		System.out.println("  avg hits per pixel: " + sum / width / height + "; max hits: " + maxHits + "; fraction zeroes: " + (float)numZeroes / width / height);
	}
	
	public Image getImage(){
		Image image = new Image(width, height);
		for(int i = 0; i < width; i++)
			for(int j = 0; j < height; j++)
				image.data[i][j] = (float)data[i][j];
		image.createDrawnImage(true);
		return image;
	}
}
