/*
 * Created on Jun 17, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jogl;
import javax.vecmath.*;

import java.util.*;

/**
 * @author golovins
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Vertex {			
	Mesh mesh;
	public Vector3d pos, objNormal, photoNormal, color;
	Vector3d newPos;
	Vector2d textureCoords;
	Vector3d uvColor;
	
	boolean marked = false;
	boolean boundary = false;
	boolean baseVertex = false;
	
	int index = -1;
	
	List faces, neighbors;
	
	boolean bright = false;

	boolean markedForDeletion = false;
	
	public Vertex(Vertex v, Mesh m){
		boundary = v.boundary;
		baseVertex = v.baseVertex;
		mesh = m;
		pos = new Vector3d(v.pos);	
		if(v.textureCoords != null)
			textureCoords = new Vector2d(v.textureCoords);
	}
	
	public Vertex(Mesh m, Vector3d pos){
		this.pos = pos;
		this.mesh = m;
	}
	
	public Vertex(Mesh m, double x, double y, double z){
		this.mesh = m;
		pos = new Vector3d(x, y, z);		
	}
	
	public Vertex(Mesh m, String vLine){
		this.mesh = m;
		pos = new Vector3d();
		StringTokenizer tokenizer = new StringTokenizer(vLine);
		tokenizer.nextToken();
		pos.x = Double.valueOf(tokenizer.nextToken()).doubleValue();
		pos.y = Double.valueOf(tokenizer.nextToken()).doubleValue();
		pos.z = Double.valueOf(tokenizer.nextToken()).doubleValue();
		//System.out.println(pos);
	}
	
	public void loadTextureCoords(String line){
		textureCoords = new Vector2d();
		StringTokenizer tokenizer = new StringTokenizer(line);
		tokenizer.nextToken();
		textureCoords.x = Double.valueOf(tokenizer.nextToken()).doubleValue();
		textureCoords.y = Double.valueOf(tokenizer.nextToken()).doubleValue();
		uvColor = new Vector3d(textureCoords.x * 70, textureCoords.y * 70, textureCoords.y * 15);	
		uvColor.x = uvColor.x - (int)uvColor.x;
		uvColor.y = uvColor.y - (int)uvColor.y;
		uvColor.z = uvColor.z - (int)uvColor.z;
	
		//System.out.println(textureCoords);
	}

	public void loadNormal(String line){
		objNormal = new Vector3d();
		StringTokenizer tokenizer = new StringTokenizer(line);
		tokenizer.nextToken();
		objNormal.x = Double.valueOf(tokenizer.nextToken()).doubleValue();
		objNormal.y = Double.valueOf(tokenizer.nextToken()).doubleValue();
		objNormal.z = Double.valueOf(tokenizer.nextToken()).doubleValue();
		//System.out.println(textureCoords);
	}
	
	public void loadTextureValues(){
		/*
		double normalX = normalTextureX[xText][yText]; 
		double normalY = normalTextureY[xText][yText]; 
		double normalZ = normalTextureZ[xText][yText];*/
		double normalX = Mesh.textureValue(textureCoords.x, textureCoords.y, mesh.normalTextureX);
		double normalY = Mesh.textureValue(textureCoords.x, textureCoords.y, mesh.normalTextureY);
		double normalZ = Mesh.textureValue(textureCoords.x, textureCoords.y, mesh.normalTextureZ);
		photoNormal = new Vector3d(normalX, normalY, normalZ);
		photoNormal.normalize();
		
		/*
		int xText = (int)(textureCoords.x * mesh.colorR.length);
		int yText = (int)(textureCoords.y * mesh.colorR[0].length);	        		
		double colorR = mesh.colorR[xText][yText];
		double colorG = mesh.colorG[xText][yText];
		double colorB = mesh.colorB[xText][yText];
		color = new Vector3d(colorR, colorG, colorB);
		*/
	}
	
	static Vector3d avg(Vector3d v1, Vector3d v2){
		Vector3d output = new Vector3d(v1);
		output.add(v2);
		output.scale(.5);
		return output;
	}
	
	static public Vertex avg(Vertex v1, Vertex v2){
		Vector3d pos = avg(v1.pos, v2.pos);
		Vertex v = new Vertex(v1.mesh, pos);
		if(v1.color != null)
			v.color = avg(v1.color, v2.color);
		if(v1.objNormal != null){
			v.objNormal = avg(v1.objNormal, v2.objNormal);
			v.objNormal.normalize();
		}
		//v.photoNormal = avg(v1.photoNormal, v2.photoNormal);
		if(v1.uvColor != null)
			v.uvColor = avg(v1.uvColor, v2.uvColor);
		
		if(v1.textureCoords != null){
			v.textureCoords = new Vector2d(v1.textureCoords);
			v.textureCoords.add(v2.textureCoords);
			v.textureCoords.scale(.5);
			
			if(v.mesh.normalTextureX != null)
				v.loadTextureValues();
		}
		v.boundary = v1.boundary && v2.boundary;
		return v;
	}
	
	public String toString(){
		return index + "";//pos.toString();
	}
}
