/*
 * Created on Aug 18, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jogl;

import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.Set;

import javax.vecmath.Vector2d;
import javax.vecmath.Vector3d;

import net.java.games.jogl.GL;

/**
 * @author golovins
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Wrinkle {
	List pixels;
	Vector3d color;
	float avgWidth, maxWidth;
	
	Pixel startPixel;
	
	Image sourceImg;
	
	//Image diffImage;
	
	public Wrinkle(List pixels, Image diffImage, Pixel startPixel){
		//this.diffImage = diffImage;
		this.startPixel = startPixel;
		this.pixels = pixels;
		for(Iterator iter = pixels.iterator(); iter.hasNext();){
			Pixel pixel = (Pixel)iter.next();
			pixel.height = diffImage.data[pixel.x][pixel.y];
		}
		color = randomBrightColor();
	}
	
	public void draw(GL gl){
		draw(gl, false);
	}
	
	public void draw(GL gl, boolean hilight){
		if(hilight)
			gl.glPointSize(3);
		else
			gl.glPointSize(1);
		gl.glBegin(GL.GL_POINTS);
		gl.glColor3d(color.x, color.y, color.z);
		for(Iterator iter = pixels.iterator(); iter.hasNext();){
			Pixel pixel = (Pixel)iter.next();
			gl.glVertex2d(pixel.x, pixel.y);
		}
		gl.glEnd();
		
		gl.glPointSize(2);
		gl.glColor3d(1, 0, 0);
		gl.glBegin(GL.GL_POINTS);
		Pixel beginPixel = (Pixel)pixels.get(0);
		Pixel endPixel = (Pixel)pixels.get(pixels.size() - 1);
		
		gl.glVertex2d(beginPixel.x, beginPixel.y);
		gl.glVertex2d(endPixel.x, endPixel.y);
		if(hilight){
			gl.glColor3d(0, 0, 0);
			gl.glVertex2d(startPixel.x, startPixel.y);
		}
		
		gl.glEnd();		
	}
	
	public void calculateWidth(Image binImage, Vector2d normalDirs[][]){
		float widthSum = 0;
		maxWidth = Float.NEGATIVE_INFINITY;
		for(int i = 0 ; i < pixels.size(); i++){
			Pixel pixel = (Pixel)pixels.get(i);
			float width = binImage.getLength(pixel, normalDirs[pixel.x][pixel.y]);
			width += binImage.getLength(pixel, normalDirs[pixel.x][pixel.y]);
			width--;
			
			pixel.width = width;
			if(width > maxWidth) maxWidth = width;
			widthSum += width;
		}
		avgWidth = widthSum / pixels.size();
		
		for(int i = 0 ; i < pixels.size(); i++){
			Pixel pixel = (Pixel)pixels.get(i);
			pixel.width = avgWidth;
		}
	}
	
	static Random rand = new Random();
	
	static Vector3d randomBrightColor(){
		int i = rand.nextInt(3);
		Vector3d color = null;
		if(i == 0)
			color = new Vector3d(rand.nextFloat()/2 + .5, rand.nextFloat()/2 + .5, rand.nextFloat()/2);		
		else if(i == 1)
			color = new Vector3d(rand.nextFloat()/2 + .5, rand.nextFloat()/2, rand.nextFloat()/2 + .5);		
		else
			color = new Vector3d(rand.nextFloat()/2, rand.nextFloat()/2 + .5, rand.nextFloat()/2 + .5);		
		return color;
	}
	
	static List getWrinkles(Image image){
		Image curvatureImage = image.edgeDetect(-0.000008f);
		Image threshCurvatureBin = image.threshCurvatureBin;
		Image thinnedCurvatureBin = new Image(threshCurvatureBin);
		thinnedCurvatureBin.suppress(curvatureImage, image.normalDirections);
		List wrinkles = Image.removeWrinkles(threshCurvatureBin, thinnedCurvatureBin, image, image.principleDirections, image.normalDirections); 
		for(int i = 0; i < wrinkles.size(); i++){
			Wrinkle wrinkle = (Wrinkle)wrinkles.get(i);
			wrinkle.sourceImg = image;
		}
		
		return wrinkles; 
	}
	
}
